import{s as Ve,n as Xe,o as Qe}from"../chunks/scheduler.182ea377.js";import{S as Ye,i as Ke,g as a,s,u as G,m as et,A as tt,h as i,f as t,c as r,j as d,v as O,y as l,n as nt,k as f,o as p,a as o,w as B,d as F,t as V,x as X}from"../chunks/index.caaccc80.js";import{I as Te}from"../chunks/IconCopyLink.3458bfff.js";import{C as Fe}from"../chunks/CodeBlock.bfd5b6e8.js";function ot($e){let u,Q,z,Y,h,g,D,b,we,N,ke="🧨 Diffusers Training Examples",K,v,Le=`Diffusers training examples are a collection of scripts to demonstrate how to effectively use the <code>diffusers</code> library
for a variety of use cases.`,ee,w,Pe=`<strong>Note</strong>: If you are looking for <strong>official</strong> examples on how to use <code>diffusers</code> for inference,
please have a look at <a href="https://github.com/huggingface/diffusers/tree/main/src/diffusers/pipelines" rel="nofollow">src/diffusers/pipelines</a>`,te,_,Me=`Our examples aspire to be <strong>self-contained</strong>, <strong>easy-to-tweak</strong>, <strong>beginner-friendly</strong> and for <strong>one-purpose-only</strong>.
More specifically, this means:`,ne,C,Ie=`<li><strong>Self-contained</strong>: An example script shall only depend on “pip-install-able” Python packages that can be found in a <code>requirements.txt</code> file. Example scripts shall <strong>not</strong> depend on any local files. This means that one can simply download an example script, <em>e.g.</em> <a href="https://github.com/huggingface/diffusers/blob/main/examples/unconditional_image_generation/train_unconditional.py" rel="nofollow">train_unconditional.py</a>, install the required dependencies, <em>e.g.</em> <a href="https://github.com/huggingface/diffusers/blob/main/examples/unconditional_image_generation/requirements.txt" rel="nofollow">requirements.txt</a> and execute the example script.</li> <li><strong>Easy-to-tweak</strong>: While we strive to present as many use cases as possible, the example scripts are just that - examples. It is expected that they won’t work out-of-the box on your specific problem and that you will be required to change a few lines of code to adapt them to your needs. To help you with that, most of the examples fully expose the preprocessing of the data and the training loop to allow you to tweak and edit them as required.</li> <li><strong>Beginner-friendly</strong>: We do not aim for providing state-of-the-art training scripts for the newest models, but rather examples that can be used as a way to better understand diffusion models and how to use them with the <code>diffusers</code> library. We often purposefully leave out certain state-of-the-art methods if we consider them too complex for beginners.</li> <li><strong>One-purpose-only</strong>: Examples should show one task and one task only. Even if a task is from a modeling
point of view very similar, <em>e.g.</em> image super-resolution and image modification tend to use the same model and training method, we want examples to showcase only one task to keep them as readable and easy-to-understand as possible.</li>`,oe,T,He=`We provide <strong>official</strong> examples that cover the most popular tasks of diffusion models.
<em>Official</em> examples are <strong>actively</strong> maintained by the <code>diffusers</code> maintainers and we try to rigorously follow our example philosophy as defined above.
If you feel like another important example should exist, we are more than happy to welcome a <a href="https://github.com/huggingface/diffusers/issues/new?assignees=&amp;labels=&amp;template=feature_request.md&amp;title=" rel="nofollow">Feature Request</a> or directly a <a href="https://github.com/huggingface/diffusers/compare" rel="nofollow">Pull Request</a> from you!`,ae,$,Ae="Training examples show how to pretrain or fine-tune diffusion models for a variety of tasks. Currently we support:",ie,k,Ee='<li><a href="./unconditional_training">Unconditional Training</a></li> <li><a href="./text2image">Text-to-Image Training</a><sup>*</sup></li> <li><a href="./text_inversion">Text Inversion</a></li> <li><a href="./dreambooth">Dreambooth</a><sup>*</sup></li> <li><a href="./lora">LoRA Support</a><sup>*</sup></li> <li><a href="./controlnet">ControlNet</a><sup>*</sup></li> <li><a href="./instructpix2pix">InstructPix2Pix</a><sup>*</sup></li> <li><a href="./custom_diffusion">Custom Diffusion</a></li> <li><a href="./t2i_adapters">T2I-Adapters</a><sup>*</sup></li>',se,L,Se="*",re,P,qe='If possible, please <a href="../optimization/xformers">install xFormers</a> for memory efficient attention. This could help make your training faster and less memory intensive.',le,M,Ue='<thead><tr><th>Task</th> <th>🤗 Accelerate</th> <th align="center">🤗 Datasets</th> <th align="center">Colab</th></tr></thead> <tbody><tr><td><a href="./unconditional_training"><strong>Unconditional Image Generation</strong></a></td> <td>✅</td> <td align="center">✅</td> <td align="center"><a href="https://colab.research.google.com/github/huggingface/notebooks/blob/main/diffusers/training_example.ipynb" rel="nofollow"><img src="https://colab.research.google.com/assets/colab-badge.svg" alt="Open In Colab"/></a></td></tr> <tr><td><a href="./text2image"><strong>Text-to-Image fine-tuning</strong></a></td> <td>✅</td> <td align="center">✅</td> <td align="center"></td></tr> <tr><td><a href="./text_inversion"><strong>Textual Inversion</strong></a></td> <td>✅</td> <td align="center">-</td> <td align="center"><a href="https://colab.research.google.com/github/huggingface/notebooks/blob/main/diffusers/sd_textual_inversion_training.ipynb" rel="nofollow"><img src="https://colab.research.google.com/assets/colab-badge.svg" alt="Open In Colab"/></a></td></tr> <tr><td><a href="./dreambooth"><strong>Dreambooth</strong></a></td> <td>✅</td> <td align="center">-</td> <td align="center"><a href="https://colab.research.google.com/github/huggingface/notebooks/blob/main/diffusers/sd_dreambooth_training.ipynb" rel="nofollow"><img src="https://colab.research.google.com/assets/colab-badge.svg" alt="Open In Colab"/></a></td></tr> <tr><td><a href="./lora"><strong>Training with LoRA</strong></a></td> <td>✅</td> <td align="center">-</td> <td align="center">-</td></tr> <tr><td><a href="./controlnet"><strong>ControlNet</strong></a></td> <td>✅</td> <td align="center">✅</td> <td align="center">-</td></tr> <tr><td><a href="./instructpix2pix"><strong>InstructPix2Pix</strong></a></td> <td>✅</td> <td align="center">✅</td> <td align="center">-</td></tr> <tr><td><a href="./custom_diffusion"><strong>Custom Diffusion</strong></a></td> <td>✅</td> <td align="center">✅</td> <td align="center">-</td></tr> <tr><td><a href="./t2i_adapters"><strong>T2I Adapters</strong></a></td> <td>✅</td> <td align="center">✅</td> <td align="center">-</td></tr></tbody>',fe,m,x,Z,I,_e,R,Ne="Community",pe,H,Re=`In addition, we provide <strong>community</strong> examples, which are examples added and maintained by our community.
Community examples can consist of both <em>training</em> examples or <em>inference</em> pipelines.
For such examples, we are more lenient regarding the philosophy defined above and also cannot guarantee to provide maintenance for every issue.
Examples that are useful for the community, but are either not yet deemed popular or not yet following our above philosophy should go into the <a href="https://github.com/huggingface/diffusers/tree/main/examples/community" rel="nofollow">community examples</a> folder. The community folder therefore includes training examples and inference pipelines.
<strong>Note</strong>: Community examples can be a <a href="https://github.com/huggingface/diffusers/issues?q=is%3Aopen+is%3Aissue+label%3A%22good+first+issue%22" rel="nofollow">great first contribution</a> to show to the community how you like to use <code>diffusers</code> 🪄.`,de,c,y,j,A,Ce,W,We="Important note",ue,E,ze="To make sure you can successfully run the latest versions of the example scripts, you have to <strong>install the library from source</strong> and install some example-specific requirements. To do this, execute the following steps in a new virtual environment:",he,S,me,q,De="Then cd in the example folder of your choice and run",ce,U,ge,J,xe;return b=new Te({}),I=new Te({}),A=new Te({}),S=new Fe({props:{code:"Z2l0JTIwY2xvbmUlMjBodHRwcyUzQSUyRiUyRmdpdGh1Yi5jb20lMkZodWdnaW5nZmFjZSUyRmRpZmZ1c2VycyUwQWNkJTIwZGlmZnVzZXJzJTBBcGlwJTIwaW5zdGFsbCUyMC4=",highlighted:`git <span class="hljs-built_in">clone</span> https://github.com/huggingface/diffusers
<span class="hljs-built_in">cd</span> diffusers
pip install .`}}),U=new Fe({props:{code:"cGlwJTIwaW5zdGFsbCUyMC1yJTIwcmVxdWlyZW1lbnRzLnR4dA==",highlighted:"pip install -r requirements.txt"}}),{c(){u=a("meta"),Q=s(),z=a("p"),Y=s(),h=a("h1"),g=a("a"),D=a("span"),G(b.$$.fragment),we=s(),N=a("span"),N.textContent=ke,K=s(),v=a("p"),v.innerHTML=Le,ee=s(),w=a("p"),w.innerHTML=Pe,te=s(),_=a("p"),_.innerHTML=Me,ne=s(),C=a("ul"),C.innerHTML=Ie,oe=s(),T=a("p"),T.innerHTML=He,ae=s(),$=a("p"),$.textContent=Ae,ie=s(),k=a("ul"),k.innerHTML=Ee,se=s(),L=a("sup"),L.textContent=Se,re=et(`: Supports [Stable Diffusion XL](../api/pipelines/stable_diffusion/stable_diffusion_xl).
`),P=a("p"),P.innerHTML=qe,le=s(),M=a("table"),M.innerHTML=Ue,fe=s(),m=a("h2"),x=a("a"),Z=a("span"),G(I.$$.fragment),_e=s(),R=a("span"),R.textContent=Ne,pe=s(),H=a("p"),H.innerHTML=Re,de=s(),c=a("h2"),y=a("a"),j=a("span"),G(A.$$.fragment),Ce=s(),W=a("span"),W.textContent=We,ue=s(),E=a("p"),E.innerHTML=ze,he=s(),G(S.$$.fragment),me=s(),q=a("p"),q.textContent=De,ce=s(),G(U.$$.fragment),ge=s(),J=a("p"),this.h()},l(e){const n=tt("svelte-1phssyn",document.head);u=i(n,"META",{name:!0,content:!0}),n.forEach(t),Q=r(e),z=i(e,"P",{}),d(z).forEach(t),Y=r(e),h=i(e,"H1",{class:!0});var ye=d(h);g=i(ye,"A",{id:!0,class:!0,href:!0});var Ze=d(g);D=i(Ze,"SPAN",{});var je=d(D);O(b.$$.fragment,je),je.forEach(t),Ze.forEach(t),we=r(ye),N=i(ye,"SPAN",{"data-svelte-h":!0}),l(N)!=="svelte-89q8af"&&(N.textContent=ke),ye.forEach(t),K=r(e),v=i(e,"P",{"data-svelte-h":!0}),l(v)!=="svelte-1082zqa"&&(v.innerHTML=Le),ee=r(e),w=i(e,"P",{"data-svelte-h":!0}),l(w)!=="svelte-1wlaraf"&&(w.innerHTML=Pe),te=r(e),_=i(e,"P",{"data-svelte-h":!0}),l(_)!=="svelte-1x8dds5"&&(_.innerHTML=Me),ne=r(e),C=i(e,"UL",{"data-svelte-h":!0}),l(C)!=="svelte-xrfy8r"&&(C.innerHTML=Ie),oe=r(e),T=i(e,"P",{"data-svelte-h":!0}),l(T)!=="svelte-10ihwxn"&&(T.innerHTML=He),ae=r(e),$=i(e,"P",{"data-svelte-h":!0}),l($)!=="svelte-11lmcpx"&&($.textContent=Ae),ie=r(e),k=i(e,"UL",{"data-svelte-h":!0}),l(k)!=="svelte-5zq2nq"&&(k.innerHTML=Ee),se=r(e),L=i(e,"SUP",{"data-svelte-h":!0}),l(L)!=="svelte-1ruaeze"&&(L.textContent=Se),re=nt(e,`: Supports [Stable Diffusion XL](../api/pipelines/stable_diffusion/stable_diffusion_xl).
`),P=i(e,"P",{"data-svelte-h":!0}),l(P)!=="svelte-1ujwbe8"&&(P.innerHTML=qe),le=r(e),M=i(e,"TABLE",{"data-svelte-h":!0}),l(M)!=="svelte-roqoa9"&&(M.innerHTML=Ue),fe=r(e),m=i(e,"H2",{class:!0});var be=d(m);x=i(be,"A",{id:!0,class:!0,href:!0});var Je=d(x);Z=i(Je,"SPAN",{});var Ge=d(Z);O(I.$$.fragment,Ge),Ge.forEach(t),Je.forEach(t),_e=r(be),R=i(be,"SPAN",{"data-svelte-h":!0}),l(R)!=="svelte-19krgu"&&(R.textContent=Ne),be.forEach(t),pe=r(e),H=i(e,"P",{"data-svelte-h":!0}),l(H)!=="svelte-1n45xd3"&&(H.innerHTML=Re),de=r(e),c=i(e,"H2",{class:!0});var ve=d(c);y=i(ve,"A",{id:!0,class:!0,href:!0});var Oe=d(y);j=i(Oe,"SPAN",{});var Be=d(j);O(A.$$.fragment,Be),Be.forEach(t),Oe.forEach(t),Ce=r(ve),W=i(ve,"SPAN",{"data-svelte-h":!0}),l(W)!=="svelte-1nifef3"&&(W.textContent=We),ve.forEach(t),ue=r(e),E=i(e,"P",{"data-svelte-h":!0}),l(E)!=="svelte-1p4ghgy"&&(E.innerHTML=ze),he=r(e),O(S.$$.fragment,e),me=r(e),q=i(e,"P",{"data-svelte-h":!0}),l(q)!=="svelte-1y5cojp"&&(q.textContent=De),ce=r(e),O(U.$$.fragment,e),ge=r(e),J=i(e,"P",{}),d(J).forEach(t),this.h()},h(){f(u,"name","hf:doc:metadata"),f(u,"content",JSON.stringify(at)),f(g,"id","diffusers-training-examples"),f(g,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(g,"href","#diffusers-training-examples"),f(h,"class","relative group"),f(x,"id","community"),f(x,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(x,"href","#community"),f(m,"class","relative group"),f(y,"id","important-note"),f(y,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(y,"href","#important-note"),f(c,"class","relative group")},m(e,n){p(document.head,u),o(e,Q,n),o(e,z,n),o(e,Y,n),o(e,h,n),p(h,g),p(g,D),B(b,D,null),p(h,we),p(h,N),o(e,K,n),o(e,v,n),o(e,ee,n),o(e,w,n),o(e,te,n),o(e,_,n),o(e,ne,n),o(e,C,n),o(e,oe,n),o(e,T,n),o(e,ae,n),o(e,$,n),o(e,ie,n),o(e,k,n),o(e,se,n),o(e,L,n),o(e,re,n),o(e,P,n),o(e,le,n),o(e,M,n),o(e,fe,n),o(e,m,n),p(m,x),p(x,Z),B(I,Z,null),p(m,_e),p(m,R),o(e,pe,n),o(e,H,n),o(e,de,n),o(e,c,n),p(c,y),p(y,j),B(A,j,null),p(c,Ce),p(c,W),o(e,ue,n),o(e,E,n),o(e,he,n),B(S,e,n),o(e,me,n),o(e,q,n),o(e,ce,n),B(U,e,n),o(e,ge,n),o(e,J,n),xe=!0},p:Xe,i(e){xe||(F(b.$$.fragment,e),F(I.$$.fragment,e),F(A.$$.fragment,e),F(S.$$.fragment,e),F(U.$$.fragment,e),xe=!0)},o(e){V(b.$$.fragment,e),V(I.$$.fragment,e),V(A.$$.fragment,e),V(S.$$.fragment,e),V(U.$$.fragment,e),xe=!1},d(e){e&&(t(Q),t(z),t(Y),t(h),t(K),t(v),t(ee),t(w),t(te),t(_),t(ne),t(C),t(oe),t(T),t(ae),t($),t(ie),t(k),t(se),t(L),t(re),t(P),t(le),t(M),t(fe),t(m),t(pe),t(H),t(de),t(c),t(ue),t(E),t(he),t(me),t(q),t(ce),t(ge),t(J)),t(u),X(b),X(I),X(A),X(S,e),X(U,e)}}}const at={local:"diffusers-training-examples",sections:[{local:"community",title:"Community"},{local:"important-note",title:"Important note"}],title:"🧨 Diffusers Training Examples"};function it($e){return Qe(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class pt extends Ye{constructor(u){super(),Ke(this,u,it,ot,Ve,{})}}export{pt as component};
