import{s as Ae,n as Ee,o as Pe}from"../chunks/scheduler.182ea377.js";import{S as Le,i as De,g as o,s as l,u as S,A as ze,h as r,f as t,c as d,j as m,v as I,y as k,k as s,o as n,a as i,w as H,d as U,t as q,x as F}from"../chunks/index.caaccc80.js";import{D as ue}from"../chunks/Docstring.835fbd1d.js";import{I as he}from"../chunks/IconCopyLink.3458bfff.js";function Se(_e){let c,W,j,Z,p,g,V,$,ie,N,ge="Transformer Temporal",G,w,Te="A Transformer model for video-like data.",K,u,T,B,x,le,A,ve="TransformerTemporalModel",Q,f,M,de,E,be="A Transformer model for video-like data.",me,v,y,fe,P,$e="The <code>TransformerTemporal</code> forward method.",X,h,b,J,C,ce,L,we="TransformerTemporalModelOutput",Y,_,O,pe,D,xe="The output of <code>TransformerTemporalModel</code>.",ee,R,te;return $=new he({}),x=new he({}),M=new ue({props:{name:"class diffusers.models.TransformerTemporalModel",anchor:"diffusers.models.TransformerTemporalModel",parameters:[{name:"num_attention_heads",val:": int = 16"},{name:"attention_head_dim",val:": int = 88"},{name:"in_channels",val:": typing.Optional[int] = None"},{name:"out_channels",val:": typing.Optional[int] = None"},{name:"num_layers",val:": int = 1"},{name:"dropout",val:": float = 0.0"},{name:"norm_num_groups",val:": int = 32"},{name:"cross_attention_dim",val:": typing.Optional[int] = None"},{name:"attention_bias",val:": bool = False"},{name:"sample_size",val:": typing.Optional[int] = None"},{name:"activation_fn",val:": str = 'geglu'"},{name:"norm_elementwise_affine",val:": bool = True"},{name:"double_self_attention",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.models.TransformerTemporalModel.num_attention_heads",description:"<strong>num_attention_heads</strong> (<code>int</code>, <em>optional</em>, defaults to 16) &#x2014; The number of heads to use for multi-head attention.",name:"num_attention_heads"},{anchor:"diffusers.models.TransformerTemporalModel.attention_head_dim",description:"<strong>attention_head_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 88) &#x2014; The number of channels in each head.",name:"attention_head_dim"},{anchor:"diffusers.models.TransformerTemporalModel.in_channels",description:`<strong>in_channels</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The number of channels in the input and output (specify if the input is <strong>continuous</strong>).`,name:"in_channels"},{anchor:"diffusers.models.TransformerTemporalModel.num_layers",description:"<strong>num_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014; The number of layers of Transformer blocks to use.",name:"num_layers"},{anchor:"diffusers.models.TransformerTemporalModel.dropout",description:"<strong>dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014; The dropout probability to use.",name:"dropout"},{anchor:"diffusers.models.TransformerTemporalModel.cross_attention_dim",description:"<strong>cross_attention_dim</strong> (<code>int</code>, <em>optional</em>) &#x2014; The number of <code>encoder_hidden_states</code> dimensions to use.",name:"cross_attention_dim"},{anchor:"diffusers.models.TransformerTemporalModel.sample_size",description:`<strong>sample_size</strong> (<code>int</code>, <em>optional</em>) &#x2014; The width of the latent images (specify if the input is <strong>discrete</strong>).
This is fixed during training since it is used to learn a number of position embeddings.`,name:"sample_size"},{anchor:"diffusers.models.TransformerTemporalModel.activation_fn",description:"<strong>activation_fn</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;geglu&quot;</code>) &#x2014; Activation function to use in feed-forward.",name:"activation_fn"},{anchor:"diffusers.models.TransformerTemporalModel.attention_bias",description:`<strong>attention_bias</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Configure if the <code>TransformerBlock</code> attention should contain a bias parameter.`,name:"attention_bias"},{anchor:"diffusers.models.TransformerTemporalModel.double_self_attention",description:`<strong>double_self_attention</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Configure if each <code>TransformerBlock</code> should contain two self-attention layers.`,name:"double_self_attention"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/transformer_temporal.py#L39"}}),y=new ue({props:{name:"forward",anchor:"diffusers.models.TransformerTemporalModel.forward",parameters:[{name:"hidden_states",val:""},{name:"encoder_hidden_states",val:" = None"},{name:"timestep",val:" = None"},{name:"class_labels",val:" = None"},{name:"num_frames",val:" = 1"},{name:"cross_attention_kwargs",val:" = None"},{name:"return_dict",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.models.TransformerTemporalModel.forward.hidden_states",description:`<strong>hidden_states</strong> (<code>torch.LongTensor</code> of shape <code>(batch size, num latent pixels)</code> if discrete, <code>torch.FloatTensor</code> of shape <code>(batch size, channel, height, width)</code> if continuous) &#x2014;
Input hidden_states.`,name:"hidden_states"},{anchor:"diffusers.models.TransformerTemporalModel.forward.encoder_hidden_states",description:`<strong>encoder_hidden_states</strong> ( <code>torch.LongTensor</code> of shape <code>(batch size, encoder_hidden_states dim)</code>, <em>optional</em>) &#x2014;
Conditional embeddings for cross attention layer. If not given, cross-attention defaults to
self-attention.`,name:"encoder_hidden_states"},{anchor:"diffusers.models.TransformerTemporalModel.forward.timestep",description:`<strong>timestep</strong> ( <code>torch.long</code>, <em>optional</em>) &#x2014;
Used to indicate denoising step. Optional timestep to be applied as an embedding in <code>AdaLayerNorm</code>.`,name:"timestep"},{anchor:"diffusers.models.TransformerTemporalModel.forward.class_labels",description:`<strong>class_labels</strong> ( <code>torch.LongTensor</code> of shape <code>(batch size, num classes)</code>, <em>optional</em>) &#x2014;
Used to indicate class labels conditioning. Optional class labels to be applied as an embedding in
<code>AdaLayerZeroNorm</code>.`,name:"class_labels"},{anchor:"diffusers.models.TransformerTemporalModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/main/en/api/models/unet2d-cond#diffusers.models.unet_2d_condition.UNet2DConditionOutput">UNet2DConditionOutput</a> instead of a plain
tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/transformer_temporal.py#L107",returnDescription:`
<p>If <code>return_dict</code> is True, an <a
  href="/docs/diffusers/main/en/api/models/transformer_temporal#diffusers.models.transformer_temporal.TransformerTemporalModelOutput"
>TransformerTemporalModelOutput</a> is
returned, otherwise a <code>tuple</code> where the first element is the sample tensor.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/main/en/api/models/transformer_temporal#diffusers.models.transformer_temporal.TransformerTemporalModelOutput"
>TransformerTemporalModelOutput</a> or <code>tuple</code></p>
`}}),C=new he({}),O=new ue({props:{name:"class diffusers.models.transformer_temporal.TransformerTemporalModelOutput",anchor:"diffusers.models.transformer_temporal.TransformerTemporalModelOutput",parameters:[{name:"sample",val:": FloatTensor"}],parametersDescription:[{anchor:"diffusers.models.transformer_temporal.TransformerTemporalModelOutput.sample",description:`<strong>sample</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size x num_frames, num_channels, height, width)</code>) &#x2014;
The hidden states output conditioned on <code>encoder_hidden_states</code> input.`,name:"sample"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/transformer_temporal.py#L27"}}),{c(){c=o("meta"),W=l(),j=o("p"),Z=l(),p=o("h1"),g=o("a"),V=o("span"),S($.$$.fragment),ie=l(),N=o("span"),N.textContent=ge,G=l(),w=o("p"),w.textContent=Te,K=l(),u=o("h2"),T=o("a"),B=o("span"),S(x.$$.fragment),le=l(),A=o("span"),A.textContent=ve,Q=l(),f=o("div"),S(M.$$.fragment),de=l(),E=o("p"),E.textContent=be,me=l(),v=o("div"),S(y.$$.fragment),fe=l(),P=o("p"),P.innerHTML=$e,X=l(),h=o("h2"),b=o("a"),J=o("span"),S(C.$$.fragment),ce=l(),L=o("span"),L.textContent=we,Y=l(),_=o("div"),S(O.$$.fragment),pe=l(),D=o("p"),D.innerHTML=xe,ee=l(),R=o("p"),this.h()},l(e){const a=ze("svelte-1phssyn",document.head);c=r(a,"META",{name:!0,content:!0}),a.forEach(t),W=d(e),j=r(e,"P",{}),m(j).forEach(t),Z=d(e),p=r(e,"H1",{class:!0});var oe=m(p);g=r(oe,"A",{id:!0,class:!0,href:!0});var Me=m(g);V=r(Me,"SPAN",{});var ye=m(V);I($.$$.fragment,ye),ye.forEach(t),Me.forEach(t),ie=d(oe),N=r(oe,"SPAN",{"data-svelte-h":!0}),k(N)!=="svelte-11vag4o"&&(N.textContent=ge),oe.forEach(t),G=d(e),w=r(e,"P",{"data-svelte-h":!0}),k(w)!=="svelte-1ywwpi7"&&(w.textContent=Te),K=d(e),u=r(e,"H2",{class:!0});var re=m(u);T=r(re,"A",{id:!0,class:!0,href:!0});var Ce=m(T);B=r(Ce,"SPAN",{});var Oe=m(B);I(x.$$.fragment,Oe),Oe.forEach(t),Ce.forEach(t),le=d(re),A=r(re,"SPAN",{"data-svelte-h":!0}),k(A)!=="svelte-7exteb"&&(A.textContent=ve),re.forEach(t),Q=d(e),f=r(e,"DIV",{class:!0});var z=m(f);I(M.$$.fragment,z),de=d(z),E=r(z,"P",{"data-svelte-h":!0}),k(E)!=="svelte-1ywwpi7"&&(E.textContent=be),me=d(z),v=r(z,"DIV",{class:!0});var ne=m(v);I(y.$$.fragment,ne),fe=d(ne),P=r(ne,"P",{"data-svelte-h":!0}),k(P)!=="svelte-14zjqkb"&&(P.innerHTML=$e),ne.forEach(t),z.forEach(t),X=d(e),h=r(e,"H2",{class:!0});var ae=m(h);b=r(ae,"A",{id:!0,class:!0,href:!0});var ke=m(b);J=r(ke,"SPAN",{});var Ne=m(J);I(C.$$.fragment,Ne),Ne.forEach(t),ke.forEach(t),ce=d(ae),L=r(ae,"SPAN",{"data-svelte-h":!0}),k(L)!=="svelte-cb8pjk"&&(L.textContent=we),ae.forEach(t),Y=d(e),_=r(e,"DIV",{class:!0});var se=m(_);I(O.$$.fragment,se),pe=d(se),D=r(se,"P",{"data-svelte-h":!0}),k(D)!=="svelte-1wdi1wk"&&(D.innerHTML=xe),se.forEach(t),ee=d(e),R=r(e,"P",{}),m(R).forEach(t),this.h()},h(){s(c,"name","hf:doc:metadata"),s(c,"content",JSON.stringify(Ie)),s(g,"id","transformer-temporal"),s(g,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(g,"href","#transformer-temporal"),s(p,"class","relative group"),s(T,"id","diffusers.models.TransformerTemporalModel"),s(T,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(T,"href","#diffusers.models.TransformerTemporalModel"),s(u,"class","relative group"),s(v,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),s(f,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),s(b,"id","diffusers.models.transformer_temporal.TransformerTemporalModelOutput"),s(b,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(b,"href","#diffusers.models.transformer_temporal.TransformerTemporalModelOutput"),s(h,"class","relative group"),s(_,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,a){n(document.head,c),i(e,W,a),i(e,j,a),i(e,Z,a),i(e,p,a),n(p,g),n(g,V),H($,V,null),n(p,ie),n(p,N),i(e,G,a),i(e,w,a),i(e,K,a),i(e,u,a),n(u,T),n(T,B),H(x,B,null),n(u,le),n(u,A),i(e,Q,a),i(e,f,a),H(M,f,null),n(f,de),n(f,E),n(f,me),n(f,v),H(y,v,null),n(v,fe),n(v,P),i(e,X,a),i(e,h,a),n(h,b),n(b,J),H(C,J,null),n(h,ce),n(h,L),i(e,Y,a),i(e,_,a),H(O,_,null),n(_,pe),n(_,D),i(e,ee,a),i(e,R,a),te=!0},p:Ee,i(e){te||(U($.$$.fragment,e),U(x.$$.fragment,e),U(M.$$.fragment,e),U(y.$$.fragment,e),U(C.$$.fragment,e),U(O.$$.fragment,e),te=!0)},o(e){q($.$$.fragment,e),q(x.$$.fragment,e),q(M.$$.fragment,e),q(y.$$.fragment,e),q(C.$$.fragment,e),q(O.$$.fragment,e),te=!1},d(e){e&&(t(W),t(j),t(Z),t(p),t(G),t(w),t(K),t(u),t(Q),t(f),t(X),t(h),t(Y),t(_),t(ee),t(R)),t(c),F($),F(x),F(M),F(y),F(C),F(O)}}}const Ie={local:"transformer-temporal",sections:[{local:"diffusers.models.TransformerTemporalModel",title:"TransformerTemporalModel"},{local:"diffusers.models.transformer_temporal.TransformerTemporalModelOutput",title:"TransformerTemporalModelOutput"}],title:"Transformer Temporal"};function He(_e){return Pe(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ve extends Le{constructor(c){super(),De(this,c,He,Se,Ae,{})}}export{Ve as component};
