import{s as Ue,o as ze,n as Ge}from"../chunks/scheduler.182ea377.js";import{S as je,i as Fe,g as a,s as o,u as O,A as Re,h as r,f as t,c as l,j as d,v as D,y as h,k as c,o as s,a as i,w as M,d as N,t as H,x as q}from"../chunks/index.caaccc80.js";import{T as We}from"../chunks/Tip.e9d11def.js";import{D as we}from"../chunks/Docstring.835fbd1d.js";import{I as xe}from"../chunks/IconCopyLink.3458bfff.js";function Be(te){let p,x='Make sure to check out the Schedulers <a href="/using-diffusers/schedulers">guide</a> to learn how to explore the tradeoff between scheduler speed and quality, and see the <a href="/using-diffusers/loading#reuse-components-across-pipelines">reuse components across pipelines</a> section to learn how to efficiently load the same components into multiple pipelines.';return{c(){p=a("p"),p.innerHTML=x},l(u){p=r(u,"P",{"data-svelte-h":!0}),h(p)!=="svelte-5fcsv6"&&(p.innerHTML=x)},m(u,U){i(u,p,U)},p:Ge,d(u){u&&t(p)}}}function Je(te){let p,x,u,U,g,y,X,C,me,z,Ce="Stochastic Karras VE",ne,I,Ie='<a href="https://huggingface.co/papers/2206.00364" rel="nofollow">Elucidating the Design Space of Diffusion-Based Generative Models</a> is by Tero Karras, Miika Aittala, Timo Aila and Samuli Laine. This pipeline implements the stochastic sampling tailored to variance expanding (VE) models.',ae,k,ke="The abstract from the paper:",re,T,Te="<em>We argue that the theory and practice of diffusion-based generative models are currently unnecessarily convoluted and seek to remedy the situation by presenting a design space that clearly separates the concrete design choices. This lets us identify several changes to both the sampling and training processes, as well as preconditioning of the score networks. Together, our improvements yield new state-of-the-art FID of 1.79 for CIFAR-10 in a class-conditional setting and 1.97 in an unconditional setting, with much faster sampling (35 network evaluations per image) than prior designs. To further demonstrate their modular nature, we show that our design changes dramatically improve both the efficiency and quality obtainable with pre-trained score networks from previous work, including improving the FID of an existing ImageNet-64 model from 2.07 to near-SOTA 1.55.</em>",se,P,ie,_,b,Y,V,ge,G,Ve="KarrasVePipeline",oe,f,E,_e,j,Ee="Pipeline for unconditional image generation.",ve,m,K,$e,F,Ke="The call function to the pipeline for generation.",ye,R,Le="Example:",le,v,w,Z,L,Pe,W,Se="ImagePipelineOutput",pe,$,S,be,B,Ae="Output class for image pipelines.",ce,ee,de;return C=new xe({}),P=new We({props:{$$slots:{default:[Be]},$$scope:{ctx:te}}}),V=new xe({}),E=new we({props:{name:"class diffusers.KarrasVePipeline",anchor:"diffusers.KarrasVePipeline",parameters:[{name:"unet",val:": UNet2DModel"},{name:"scheduler",val:": KarrasVeScheduler"}],parametersDescription:[{anchor:"diffusers.KarrasVePipeline.unet",description:`<strong>unet</strong> (<a href="/docs/diffusers/main/en/api/models/unet2d#diffusers.UNet2DModel">UNet2DModel</a>) &#x2014;
A <code>UNet2DModel</code> to denoise the encoded image.`,name:"unet"},{anchor:"diffusers.KarrasVePipeline.scheduler",description:`<strong>scheduler</strong> (<a href="/docs/diffusers/main/en/api/schedulers/stochastic_karras_ve#diffusers.KarrasVeScheduler">KarrasVeScheduler</a>) &#x2014;
A scheduler to be used in combination with <code>unet</code> to denoise the encoded image.`,name:"scheduler"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/stochastic_karras_ve/pipeline_stochastic_karras_ve.py#L25"}}),K=new we({props:{name:"__call__",anchor:"diffusers.KarrasVePipeline.__call__",parameters:[{name:"batch_size",val:": int = 1"},{name:"num_inference_steps",val:": int = 50"},{name:"generator",val:": typing.Union[torch._C.Generator, typing.List[torch._C.Generator], NoneType] = None"},{name:"output_type",val:": typing.Optional[str] = 'pil'"},{name:"return_dict",val:": bool = True"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"diffusers.KarrasVePipeline.__call__.batch_size",description:`<strong>batch_size</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The number of images to generate.`,name:"batch_size"},{anchor:"diffusers.KarrasVePipeline.__call__.generator",description:`<strong>generator</strong> (<code>torch.Generator</code>, <em>optional</em>) &#x2014;
A <a href="https://pytorch.org/docs/stable/generated/torch.Generator.html" rel="nofollow"><code>torch.Generator</code></a> to make
generation deterministic.`,name:"generator"},{anchor:"diffusers.KarrasVePipeline.__call__.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 50) &#x2014;
The number of denoising steps. More denoising steps usually lead to a higher quality image at the
expense of slower inference.`,name:"num_inference_steps"},{anchor:"diffusers.KarrasVePipeline.__call__.output_type",description:`<strong>output_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;pil&quot;</code>) &#x2014;
The output format of the generated image. Choose between <code>PIL.Image</code> or <code>np.array</code>.`,name:"output_type"},{anchor:"diffusers.KarrasVePipeline.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/main/en/api/pipelines/latent_diffusion#diffusers.ImagePipelineOutput">ImagePipelineOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/stochastic_karras_ve/pipeline_stochastic_karras_ve.py#L44",returnDescription:`
<p>If <code>return_dict</code> is <code>True</code>, <a
  href="/docs/diffusers/main/en/api/pipelines/latent_diffusion#diffusers.ImagePipelineOutput"
>ImagePipelineOutput</a> is returned, otherwise a <code>tuple</code> is
returned where the first element is a list with the generated images.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/main/en/api/pipelines/latent_diffusion#diffusers.ImagePipelineOutput"
>ImagePipelineOutput</a> or <code>tuple</code></p>
`}}),L=new xe({}),S=new we({props:{name:"class diffusers.ImagePipelineOutput",anchor:"diffusers.ImagePipelineOutput",parameters:[{name:"images",val:": typing.Union[typing.List[PIL.Image.Image], numpy.ndarray]"}],parametersDescription:[{anchor:"diffusers.ImagePipelineOutput.images",description:`<strong>images</strong> (<code>List[PIL.Image.Image]</code> or <code>np.ndarray</code>) &#x2014;
List of denoised PIL images of length <code>batch_size</code> or NumPy array of shape <code>(batch_size, height, width, num_channels)</code>.`,name:"images"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/pipeline_utils.py#L112"}}),{c(){p=a("meta"),x=o(),u=a("p"),U=o(),g=a("h1"),y=a("a"),X=a("span"),O(C.$$.fragment),me=o(),z=a("span"),z.textContent=Ce,ne=o(),I=a("p"),I.innerHTML=Ie,ae=o(),k=a("p"),k.textContent=ke,re=o(),T=a("p"),T.innerHTML=Te,se=o(),O(P.$$.fragment),ie=o(),_=a("h2"),b=a("a"),Y=a("span"),O(V.$$.fragment),ge=o(),G=a("span"),G.textContent=Ve,oe=o(),f=a("div"),O(E.$$.fragment),_e=o(),j=a("p"),j.textContent=Ee,ve=o(),m=a("div"),O(K.$$.fragment),$e=o(),F=a("p"),F.textContent=Ke,ye=o(),R=a("p"),R.textContent=Le,le=o(),v=a("h2"),w=a("a"),Z=a("span"),O(L.$$.fragment),Pe=o(),W=a("span"),W.textContent=Se,pe=o(),$=a("div"),O(S.$$.fragment),be=o(),B=a("p"),B.textContent=Ae,ce=o(),ee=a("p"),this.h()},l(e){const n=Re("svelte-1phssyn",document.head);p=r(n,"META",{name:!0,content:!0}),n.forEach(t),x=l(e),u=r(e,"P",{}),d(u).forEach(t),U=l(e),g=r(e,"H1",{class:!0});var A=d(g);y=r(A,"A",{id:!0,class:!0,href:!0});var Oe=d(y);X=r(Oe,"SPAN",{});var De=d(X);D(C.$$.fragment,De),De.forEach(t),Oe.forEach(t),me=l(A),z=r(A,"SPAN",{"data-svelte-h":!0}),h(z)!=="svelte-1ac9cbh"&&(z.textContent=Ce),A.forEach(t),ne=l(e),I=r(e,"P",{"data-svelte-h":!0}),h(I)!=="svelte-1a5vxii"&&(I.innerHTML=Ie),ae=l(e),k=r(e,"P",{"data-svelte-h":!0}),h(k)!=="svelte-jqf0eu"&&(k.textContent=ke),re=l(e),T=r(e,"P",{"data-svelte-h":!0}),h(T)!=="svelte-1f7fbd0"&&(T.innerHTML=Te),se=l(e),D(P.$$.fragment,e),ie=l(e),_=r(e,"H2",{class:!0});var ue=d(_);b=r(ue,"A",{id:!0,class:!0,href:!0});var Me=d(b);Y=r(Me,"SPAN",{});var Ne=d(Y);D(V.$$.fragment,Ne),Ne.forEach(t),Me.forEach(t),ge=l(ue),G=r(ue,"SPAN",{"data-svelte-h":!0}),h(G)!=="svelte-1utvl0o"&&(G.textContent=Ve),ue.forEach(t),oe=l(e),f=r(e,"DIV",{class:!0});var J=d(f);D(E.$$.fragment,J),_e=l(J),j=r(J,"P",{"data-svelte-h":!0}),h(j)!=="svelte-1byevm7"&&(j.textContent=Ee),ve=l(J),m=r(J,"DIV",{class:!0});var Q=d(m);D(K.$$.fragment,Q),$e=l(Q),F=r(Q,"P",{"data-svelte-h":!0}),h(F)!=="svelte-50j04k"&&(F.textContent=Ke),ye=l(Q),R=r(Q,"P",{"data-svelte-h":!0}),h(R)!=="svelte-11lpom8"&&(R.textContent=Le),Q.forEach(t),J.forEach(t),le=l(e),v=r(e,"H2",{class:!0});var fe=d(v);w=r(fe,"A",{id:!0,class:!0,href:!0});var He=d(w);Z=r(He,"SPAN",{});var qe=d(Z);D(L.$$.fragment,qe),qe.forEach(t),He.forEach(t),Pe=l(fe),W=r(fe,"SPAN",{"data-svelte-h":!0}),h(W)!=="svelte-1ula3t"&&(W.textContent=Se),fe.forEach(t),pe=l(e),$=r(e,"DIV",{class:!0});var he=d($);D(S.$$.fragment,he),be=l(he),B=r(he,"P",{"data-svelte-h":!0}),h(B)!=="svelte-19wetgi"&&(B.textContent=Ae),he.forEach(t),ce=l(e),ee=r(e,"P",{}),d(ee).forEach(t),this.h()},h(){c(p,"name","hf:doc:metadata"),c(p,"content",JSON.stringify(Qe)),c(y,"id","stochastic-karras-ve"),c(y,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(y,"href","#stochastic-karras-ve"),c(g,"class","relative group"),c(b,"id","diffusers.KarrasVePipeline"),c(b,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(b,"href","#diffusers.KarrasVePipeline"),c(_,"class","relative group"),c(m,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(f,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(w,"id","diffusers.ImagePipelineOutput"),c(w,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(w,"href","#diffusers.ImagePipelineOutput"),c(v,"class","relative group"),c($,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,n){s(document.head,p),i(e,x,n),i(e,u,n),i(e,U,n),i(e,g,n),s(g,y),s(y,X),M(C,X,null),s(g,me),s(g,z),i(e,ne,n),i(e,I,n),i(e,ae,n),i(e,k,n),i(e,re,n),i(e,T,n),i(e,se,n),M(P,e,n),i(e,ie,n),i(e,_,n),s(_,b),s(b,Y),M(V,Y,null),s(_,ge),s(_,G),i(e,oe,n),i(e,f,n),M(E,f,null),s(f,_e),s(f,j),s(f,ve),s(f,m),M(K,m,null),s(m,$e),s(m,F),s(m,ye),s(m,R),i(e,le,n),i(e,v,n),s(v,w),s(w,Z),M(L,Z,null),s(v,Pe),s(v,W),i(e,pe,n),i(e,$,n),M(S,$,null),s($,be),s($,B),i(e,ce,n),i(e,ee,n),de=!0},p(e,[n]){const A={};n&2&&(A.$$scope={dirty:n,ctx:e}),P.$set(A)},i(e){de||(N(C.$$.fragment,e),N(P.$$.fragment,e),N(V.$$.fragment,e),N(E.$$.fragment,e),N(K.$$.fragment,e),N(L.$$.fragment,e),N(S.$$.fragment,e),de=!0)},o(e){H(C.$$.fragment,e),H(P.$$.fragment,e),H(V.$$.fragment,e),H(E.$$.fragment,e),H(K.$$.fragment,e),H(L.$$.fragment,e),H(S.$$.fragment,e),de=!1},d(e){e&&(t(x),t(u),t(U),t(g),t(ne),t(I),t(ae),t(k),t(re),t(T),t(se),t(ie),t(_),t(oe),t(f),t(le),t(v),t(pe),t($),t(ce),t(ee)),t(p),q(C),q(P,e),q(V),q(E),q(K),q(L),q(S)}}}const Qe={local:"stochastic-karras-ve",sections:[{local:"diffusers.KarrasVePipeline",title:"KarrasVePipeline"},{local:"diffusers.ImagePipelineOutput",title:"ImagePipelineOutput"}],title:"Stochastic Karras VE"};function Xe(te){return ze(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class at extends je{constructor(p){super(),Fe(this,p,Xe,Je,Ue,{})}}export{at as component};
