import{s as _e,o as $e,n as Pe}from"../chunks/scheduler.182ea377.js";import{S as ye,i as Le,g as a,s as r,u as Q,A as Me,h as o,f as t,c as l,j as g,v as X,y as h,k as f,o as d,a as i,w as Z,d as ee,t as te,x as ne}from"../chunks/index.caaccc80.js";import{T as Ce}from"../chunks/Tip.e9d11def.js";import{D as De}from"../chunks/Docstring.835fbd1d.js";import{I as we}from"../chunks/IconCopyLink.3458bfff.js";function Te(G){let s,w="🧪 This is an experimental pipeline for reinforcement learning!";return{c(){s=a("p"),s.textContent=w},l(u){s=o(u,"P",{"data-svelte-h":!0}),h(s)!=="svelte-13bwjls"&&(s.textContent=w)},m(u,k){i(u,s,k)},p:Pe,d(u){u&&t(s)}}}function ke(G){let s,w,u,k,c,v,j,_,ie,S,re="Value-guided planning",U,x,z,$,le='This pipeline is based on the <a href="https://huggingface.co/papers/2205.09991" rel="nofollow">Planning with Diffusion for Flexible Behavior Synthesis</a> paper by Michael Janner, Yilun Du, Joshua B. Tenenbaum, Sergey Levine.',I,P,de="The abstract from the paper is:",J,y,ue="<em>Model-based reinforcement learning methods often use learning only for the purpose of estimating an approximate dynamics model, offloading the rest of the decision-making work to classical trajectory optimizers. While conceptually simple, this combination has a number of empirical shortcomings, suggesting that learned models may not be well-suited to standard trajectory optimization. In this paper, we consider what it would look like to fold as much of the trajectory optimization pipeline as possible into the modeling problem, such that sampling from the model and planning with it become nearly identical. The core of our technical approach lies in a diffusion probabilistic model that plans by iteratively denoising trajectories. We show how classifier-guided sampling and image inpainting can be reinterpreted as coherent planning strategies, explore the unusual and useful properties of diffusion-based planning methods, and demonstrate the effectiveness of our framework in control settings that emphasize long-horizon decision-making and test-time flexibility</em>.",q,L,pe='You can find additional information about the model on the <a href="https://diffusion-planning.github.io/" rel="nofollow">project page</a>, the <a href="https://github.com/jannerm/diffuser" rel="nofollow">original codebase</a>, or try it out in a demo <a href="https://colab.research.google.com/github/huggingface/notebooks/blob/main/diffusers/reinforcement_learning_with_diffusers.ipynb" rel="nofollow">notebook</a>.',B,M,fe='The script to run the model is available <a href="https://github.com/huggingface/diffusers/tree/main/examples/reinforcement_learning" rel="nofollow">here</a>.',F,m,b,R,C,ae,V,he="ValueGuidedRLPipeline",O,p,D,oe,A,ce="Pipeline for value-guided sampling from a diffusion model trained to predict sequences of states.",se,H,me=`This model inherits from <a href="/docs/diffusers/main/en/api/pipelines/overview#diffusers.DiffusionPipeline">DiffusionPipeline</a>. Check the superclass documentation for the generic methods
implemented for all pipelines (downloading, saving, running on a particular device, etc.).`,W,E,Y;return _=new we({}),x=new Ce({props:{warning:!0,$$slots:{default:[Te]},$$scope:{ctx:G}}}),C=new we({}),D=new De({props:{name:"class diffusers.experimental.ValueGuidedRLPipeline",anchor:"diffusers.experimental.ValueGuidedRLPipeline",parameters:[{name:"value_function",val:": UNet1DModel"},{name:"unet",val:": UNet1DModel"},{name:"scheduler",val:": DDPMScheduler"},{name:"env",val:""}],parametersDescription:[{anchor:"diffusers.experimental.ValueGuidedRLPipeline.value_function",description:`<strong>value_function</strong> (<a href="/docs/diffusers/main/en/api/models/unet#diffusers.UNet1DModel">UNet1DModel</a>) &#x2014;
A specialized UNet for fine-tuning trajectories base on reward.`,name:"value_function"},{anchor:"diffusers.experimental.ValueGuidedRLPipeline.unet",description:`<strong>unet</strong> (<a href="/docs/diffusers/main/en/api/models/unet#diffusers.UNet1DModel">UNet1DModel</a>) &#x2014;
UNet architecture to denoise the encoded trajectories.`,name:"unet"},{anchor:"diffusers.experimental.ValueGuidedRLPipeline.scheduler",description:`<strong>scheduler</strong> (<a href="/docs/diffusers/main/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a>) &#x2014;
A scheduler to be used in combination with <code>unet</code> to denoise the encoded trajectories. Default for this
application is <a href="/docs/diffusers/main/en/api/schedulers/ddpm#diffusers.DDPMScheduler">DDPMScheduler</a>.`,name:"scheduler"},{anchor:"diffusers.experimental.ValueGuidedRLPipeline.env",description:`<strong>env</strong> () &#x2014;
An environment following the OpenAI gym API to act in. For now only Hopper has pretrained models.`,name:"env"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/experimental/rl/value_guided_sampling.py#L25"}}),{c(){s=a("meta"),w=r(),u=a("p"),k=r(),c=a("h1"),v=a("a"),j=a("span"),Q(_.$$.fragment),ie=r(),S=a("span"),S.textContent=re,U=r(),Q(x.$$.fragment),z=r(),$=a("p"),$.innerHTML=le,I=r(),P=a("p"),P.textContent=de,J=r(),y=a("p"),y.innerHTML=ue,q=r(),L=a("p"),L.innerHTML=pe,B=r(),M=a("p"),M.innerHTML=fe,F=r(),m=a("h2"),b=a("a"),R=a("span"),Q(C.$$.fragment),ae=r(),V=a("span"),V.textContent=he,O=r(),p=a("div"),Q(D.$$.fragment),oe=r(),A=a("p"),A.textContent=ce,se=r(),H=a("p"),H.innerHTML=me,W=r(),E=a("p"),this.h()},l(e){const n=Me("svelte-1phssyn",document.head);s=o(n,"META",{name:!0,content:!0}),n.forEach(t),w=l(e),u=o(e,"P",{}),g(u).forEach(t),k=l(e),c=o(e,"H1",{class:!0});var T=g(c);v=o(T,"A",{id:!0,class:!0,href:!0});var ge=g(v);j=o(ge,"SPAN",{});var ve=g(j);X(_.$$.fragment,ve),ve.forEach(t),ge.forEach(t),ie=l(T),S=o(T,"SPAN",{"data-svelte-h":!0}),h(S)!=="svelte-10uwy0e"&&(S.textContent=re),T.forEach(t),U=l(e),X(x.$$.fragment,e),z=l(e),$=o(e,"P",{"data-svelte-h":!0}),h($)!=="svelte-1dguds4"&&($.innerHTML=le),I=l(e),P=o(e,"P",{"data-svelte-h":!0}),h(P)!=="svelte-1cwsb16"&&(P.textContent=de),J=l(e),y=o(e,"P",{"data-svelte-h":!0}),h(y)!=="svelte-5lwooz"&&(y.innerHTML=ue),q=l(e),L=o(e,"P",{"data-svelte-h":!0}),h(L)!=="svelte-1llus9j"&&(L.innerHTML=pe),B=l(e),M=o(e,"P",{"data-svelte-h":!0}),h(M)!=="svelte-guadao"&&(M.innerHTML=fe),F=l(e),m=o(e,"H2",{class:!0});var K=g(m);b=o(K,"A",{id:!0,class:!0,href:!0});var xe=g(b);R=o(xe,"SPAN",{});var be=g(R);X(C.$$.fragment,be),be.forEach(t),xe.forEach(t),ae=l(K),V=o(K,"SPAN",{"data-svelte-h":!0}),h(V)!=="svelte-m3yfpa"&&(V.textContent=he),K.forEach(t),O=l(e),p=o(e,"DIV",{class:!0});var N=g(p);X(D.$$.fragment,N),oe=l(N),A=o(N,"P",{"data-svelte-h":!0}),h(A)!=="svelte-apl1xd"&&(A.textContent=ce),se=l(N),H=o(N,"P",{"data-svelte-h":!0}),h(H)!=="svelte-496sm0"&&(H.innerHTML=me),N.forEach(t),W=l(e),E=o(e,"P",{}),g(E).forEach(t),this.h()},h(){f(s,"name","hf:doc:metadata"),f(s,"content",JSON.stringify(Se)),f(v,"id","valueguided-planning"),f(v,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(v,"href","#valueguided-planning"),f(c,"class","relative group"),f(b,"id","diffusers.experimental.ValueGuidedRLPipeline"),f(b,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(b,"href","#diffusers.experimental.ValueGuidedRLPipeline"),f(m,"class","relative group"),f(p,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,n){d(document.head,s),i(e,w,n),i(e,u,n),i(e,k,n),i(e,c,n),d(c,v),d(v,j),Z(_,j,null),d(c,ie),d(c,S),i(e,U,n),Z(x,e,n),i(e,z,n),i(e,$,n),i(e,I,n),i(e,P,n),i(e,J,n),i(e,y,n),i(e,q,n),i(e,L,n),i(e,B,n),i(e,M,n),i(e,F,n),i(e,m,n),d(m,b),d(b,R),Z(C,R,null),d(m,ae),d(m,V),i(e,O,n),i(e,p,n),Z(D,p,null),d(p,oe),d(p,A),d(p,se),d(p,H),i(e,W,n),i(e,E,n),Y=!0},p(e,[n]){const T={};n&2&&(T.$$scope={dirty:n,ctx:e}),x.$set(T)},i(e){Y||(ee(_.$$.fragment,e),ee(x.$$.fragment,e),ee(C.$$.fragment,e),ee(D.$$.fragment,e),Y=!0)},o(e){te(_.$$.fragment,e),te(x.$$.fragment,e),te(C.$$.fragment,e),te(D.$$.fragment,e),Y=!1},d(e){e&&(t(w),t(u),t(k),t(c),t(U),t(z),t($),t(I),t(P),t(J),t(y),t(q),t(L),t(B),t(M),t(F),t(m),t(O),t(p),t(W),t(E)),t(s),ne(_),ne(x,e),ne(C),ne(D)}}}const Se={local:"valueguided-planning",sections:[{local:"diffusers.experimental.ValueGuidedRLPipeline",title:"ValueGuidedRLPipeline"}],title:"Value-guided planning"};function Ve(G){return $e(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ee extends ye{constructor(s){super(),Le(this,s,Ve,ke,_e,{})}}export{Ee as component};
