import{s as Ce,n as Ee,o as Pe}from"../chunks/scheduler.182ea377.js";import{S as Fe,i as Le,g as n,s as a,u as A,A as Ne,h as o,f as t,c as i,j as p,v as q,y as I,k as c,o as s,a as u,w as H,d as z,t as O,x as V}from"../chunks/index.caaccc80.js";import{D as oe}from"../chunks/Docstring.835fbd1d.js";import{I as we}from"../chunks/IconCopyLink.3458bfff.js";function ke(me){let h,j,R,G,f,_,U,x,re,C,_e="DDIMInverseScheduler",Y,S,ge=`<code>DDIMInverseScheduler</code> is the inverted scheduler from <a href="https://huggingface.co/papers/2010.02502" rel="nofollow">Denoising Diffusion Implicit Models</a> (DDIM) by Jiaming Song, Chenlin Meng and Stefano Ermon.
The implementation is mostly based on the DDIM inversion definition from <a href="https://huggingface.co/papers/2211.09794.pdf" rel="nofollow">Null-text Inversion for Editing Real Images using Guided Diffusion Models</a>.`,B,m,g,W,y,ae,E,ve="DDIMInverseScheduler",K,r,M,ie,P,be='<code>DDIMInverseScheduler</code> is the reverse scheduler of <a href="/docs/diffusers/main/en/api/schedulers/ddim#diffusers.DDIMScheduler">DDIMScheduler</a>.',de,F,De=`This model inherits from <a href="/docs/diffusers/main/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a> and <a href="/docs/diffusers/main/en/api/configuration#diffusers.ConfigMixin">ConfigMixin</a>. Check the superclass documentation for the generic
methods the library implements for all schedulers such as loading and saving.`,ce,v,$,le,L,Ie=`Ensures interchangeability with schedulers that need to scale the denoising model input depending on the
current timestep.`,pe,b,T,ue,N,xe="Sets the discrete timesteps used for the diffusion chain (to be run before inference).",he,D,w,fe,k,Se=`Predict the sample from the previous timestep by reversing the SDE. This function propagates the diffusion
process from the learned model outputs (most often the predicted noise).`,Q,J,X;return x=new we({}),y=new we({}),M=new oe({props:{name:"class diffusers.DDIMInverseScheduler",anchor:"diffusers.DDIMInverseScheduler",parameters:[{name:"num_train_timesteps",val:": int = 1000"},{name:"beta_start",val:": float = 0.0001"},{name:"beta_end",val:": float = 0.02"},{name:"beta_schedule",val:": str = 'linear'"},{name:"trained_betas",val:": typing.Union[numpy.ndarray, typing.List[float], NoneType] = None"},{name:"clip_sample",val:": bool = True"},{name:"set_alpha_to_one",val:": bool = True"},{name:"steps_offset",val:": int = 0"},{name:"prediction_type",val:": str = 'epsilon'"},{name:"clip_sample_range",val:": float = 1.0"},{name:"timestep_spacing",val:": str = 'leading'"},{name:"rescale_betas_zero_snr",val:": bool = False"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"diffusers.DDIMInverseScheduler.num_train_timesteps",description:`<strong>num_train_timesteps</strong> (<code>int</code>, defaults to 1000) &#x2014;
The number of diffusion steps to train the model.`,name:"num_train_timesteps"},{anchor:"diffusers.DDIMInverseScheduler.beta_start",description:`<strong>beta_start</strong> (<code>float</code>, defaults to 0.0001) &#x2014;
The starting <code>beta</code> value of inference.`,name:"beta_start"},{anchor:"diffusers.DDIMInverseScheduler.beta_end",description:`<strong>beta_end</strong> (<code>float</code>, defaults to 0.02) &#x2014;
The final <code>beta</code> value.`,name:"beta_end"},{anchor:"diffusers.DDIMInverseScheduler.beta_schedule",description:`<strong>beta_schedule</strong> (<code>str</code>, defaults to <code>&quot;linear&quot;</code>) &#x2014;
The beta schedule, a mapping from a beta range to a sequence of betas for stepping the model. Choose from
<code>linear</code>, <code>scaled_linear</code>, or <code>squaredcos_cap_v2</code>.`,name:"beta_schedule"},{anchor:"diffusers.DDIMInverseScheduler.trained_betas",description:`<strong>trained_betas</strong> (<code>np.ndarray</code>, <em>optional</em>) &#x2014;
Pass an array of betas directly to the constructor to bypass <code>beta_start</code> and <code>beta_end</code>.`,name:"trained_betas"},{anchor:"diffusers.DDIMInverseScheduler.clip_sample",description:`<strong>clip_sample</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Clip the predicted sample for numerical stability.`,name:"clip_sample"},{anchor:"diffusers.DDIMInverseScheduler.clip_sample_range",description:`<strong>clip_sample_range</strong> (<code>float</code>, defaults to 1.0) &#x2014;
The maximum magnitude for sample clipping. Valid only when <code>clip_sample=True</code>.`,name:"clip_sample_range"},{anchor:"diffusers.DDIMInverseScheduler.set_alpha_to_one",description:`<strong>set_alpha_to_one</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Each diffusion step uses the alphas product value at that step and at the previous one. For the final step
there is no previous alpha. When this option is <code>True</code> the previous alpha product is fixed to 0, otherwise
it uses the alpha value at step <code>num_train_timesteps - 1</code>.`,name:"set_alpha_to_one"},{anchor:"diffusers.DDIMInverseScheduler.steps_offset",description:`<strong>steps_offset</strong> (<code>int</code>, defaults to 0) &#x2014;
An offset added to the inference steps. You can use a combination of <code>offset=1</code> and
<code>set_alpha_to_one=False</code> to make the last step use <code>num_train_timesteps - 1</code> for the previous alpha
product.`,name:"steps_offset"},{anchor:"diffusers.DDIMInverseScheduler.prediction_type",description:`<strong>prediction_type</strong> (<code>str</code>, defaults to <code>epsilon</code>, <em>optional</em>) &#x2014;
Prediction type of the scheduler function; can be <code>epsilon</code> (predicts the noise of the diffusion process),
<code>sample</code> (directly predicts the noisy sample<code>) or </code>v_prediction\` (see section 2.4 of <a href="https://imagen.research.google/video/paper.pdf" rel="nofollow">Imagen
Video</a> paper).`,name:"prediction_type"},{anchor:"diffusers.DDIMInverseScheduler.timestep_spacing",description:`<strong>timestep_spacing</strong> (<code>str</code>, defaults to <code>&quot;leading&quot;</code>) &#x2014;
The way the timesteps should be scaled. Refer to Table 2 of the <a href="https://huggingface.co/papers/2305.08891" rel="nofollow">Common Diffusion Noise Schedules and
Sample Steps are Flawed</a> for more information.`,name:"timestep_spacing"},{anchor:"diffusers.DDIMInverseScheduler.rescale_betas_zero_snr",description:`<strong>rescale_betas_zero_snr</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to rescale the betas to have zero terminal SNR. This enables the model to generate very bright and
dark samples instead of limiting it to samples with medium brightness. Loosely related to
<a href="https://github.com/huggingface/diffusers/blob/74fd735eb073eb1d774b1ab4154a0876eb82f055/examples/dreambooth/train_dreambooth.py#L506" rel="nofollow"><code>--offset_noise</code></a>.`,name:"rescale_betas_zero_snr"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_ddim_inverse.py#L130"}}),$=new oe({props:{name:"scale_model_input",anchor:"diffusers.DDIMInverseScheduler.scale_model_input",parameters:[{name:"sample",val:": FloatTensor"},{name:"timestep",val:": typing.Optional[int] = None"}],parametersDescription:[{anchor:"diffusers.DDIMInverseScheduler.scale_model_input.sample",description:`<strong>sample</strong> (<code>torch.FloatTensor</code>) &#x2014;
The input sample.`,name:"sample"},{anchor:"diffusers.DDIMInverseScheduler.scale_model_input.timestep",description:`<strong>timestep</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The current timestep in the diffusion chain.`,name:"timestep"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_ddim_inverse.py#L238",returnDescription:`
<p>A scaled input sample.</p>
`,returnType:`
<p><code>torch.FloatTensor</code></p>
`}}),T=new oe({props:{name:"set_timesteps",anchor:"diffusers.DDIMInverseScheduler.set_timesteps",parameters:[{name:"num_inference_steps",val:": int"},{name:"device",val:": typing.Union[str, torch.device] = None"}],parametersDescription:[{anchor:"diffusers.DDIMInverseScheduler.set_timesteps.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>) &#x2014;
The number of diffusion steps used when generating samples with a pre-trained model.`,name:"num_inference_steps"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_ddim_inverse.py#L255"}}),w=new oe({props:{name:"step",anchor:"diffusers.DDIMInverseScheduler.step",parameters:[{name:"model_output",val:": FloatTensor"},{name:"timestep",val:": int"},{name:"sample",val:": FloatTensor"},{name:"eta",val:": float = 0.0"},{name:"use_clipped_model_output",val:": bool = False"},{name:"variance_noise",val:": typing.Optional[torch.FloatTensor] = None"},{name:"return_dict",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.DDIMInverseScheduler.step.model_output",description:`<strong>model_output</strong> (<code>torch.FloatTensor</code>) &#x2014;
The direct output from learned diffusion model.`,name:"model_output"},{anchor:"diffusers.DDIMInverseScheduler.step.timestep",description:`<strong>timestep</strong> (<code>float</code>) &#x2014;
The current discrete timestep in the diffusion chain.`,name:"timestep"},{anchor:"diffusers.DDIMInverseScheduler.step.sample",description:`<strong>sample</strong> (<code>torch.FloatTensor</code>) &#x2014;
A current instance of a sample created by the diffusion process.`,name:"sample"},{anchor:"diffusers.DDIMInverseScheduler.step.eta",description:`<strong>eta</strong> (<code>float</code>) &#x2014;
The weight of noise for added noise in diffusion step.`,name:"eta"},{anchor:"diffusers.DDIMInverseScheduler.step.use_clipped_model_output",description:`<strong>use_clipped_model_output</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
If <code>True</code>, computes &#x201C;corrected&#x201D; <code>model_output</code> from the clipped predicted original sample. Necessary
because predicted original sample is clipped to [-1, 1] when <code>self.config.clip_sample</code> is <code>True</code>. If no
clipping has happened, &#x201C;corrected&#x201D; <code>model_output</code> would coincide with the one provided as input and
<code>use_clipped_model_output</code> has no effect.`,name:"use_clipped_model_output"},{anchor:"diffusers.DDIMInverseScheduler.step.variance_noise",description:`<strong>variance_noise</strong> (<code>torch.FloatTensor</code>) &#x2014;
Alternative to generating noise with <code>generator</code> by directly providing the noise for the variance
itself. Useful for methods such as <code>CycleDiffusion</code>.`,name:"variance_noise"},{anchor:"diffusers.DDIMInverseScheduler.step.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <code>~schedulers.scheduling_ddim_inverse.DDIMInverseSchedulerOutput</code> or
<code>tuple</code>.`,name:"return_dict"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_ddim_inverse.py#L296",returnDescription:`
<p>If return_dict is <code>True</code>, <code>~schedulers.scheduling_ddim_inverse.DDIMInverseSchedulerOutput</code> is
returned, otherwise a tuple is returned where the first element is the sample tensor.</p>
`,returnType:`
<p><code>~schedulers.scheduling_ddim_inverse.DDIMInverseSchedulerOutput</code> or <code>tuple</code></p>
`}}),{c(){h=n("meta"),j=a(),R=n("p"),G=a(),f=n("h1"),_=n("a"),U=n("span"),A(x.$$.fragment),re=a(),C=n("span"),C.textContent=_e,Y=a(),S=n("p"),S.innerHTML=ge,B=a(),m=n("h2"),g=n("a"),W=n("span"),A(y.$$.fragment),ae=a(),E=n("span"),E.textContent=ve,K=a(),r=n("div"),A(M.$$.fragment),ie=a(),P=n("p"),P.innerHTML=be,de=a(),F=n("p"),F.innerHTML=De,ce=a(),v=n("div"),A($.$$.fragment),le=a(),L=n("p"),L.textContent=Ie,pe=a(),b=n("div"),A(T.$$.fragment),ue=a(),N=n("p"),N.textContent=xe,he=a(),D=n("div"),A(w.$$.fragment),fe=a(),k=n("p"),k.textContent=Se,Q=a(),J=n("p"),this.h()},l(e){const d=Ne("svelte-1phssyn",document.head);h=o(d,"META",{name:!0,content:!0}),d.forEach(t),j=i(e),R=o(e,"P",{}),p(R).forEach(t),G=i(e),f=o(e,"H1",{class:!0});var Z=p(f);_=o(Z,"A",{id:!0,class:!0,href:!0});var ye=p(_);U=o(ye,"SPAN",{});var Me=p(U);q(x.$$.fragment,Me),Me.forEach(t),ye.forEach(t),re=i(Z),C=o(Z,"SPAN",{"data-svelte-h":!0}),I(C)!=="svelte-1bbsn14"&&(C.textContent=_e),Z.forEach(t),Y=i(e),S=o(e,"P",{"data-svelte-h":!0}),I(S)!=="svelte-1h2rvze"&&(S.innerHTML=ge),B=i(e),m=o(e,"H2",{class:!0});var ee=p(m);g=o(ee,"A",{id:!0,class:!0,href:!0});var $e=p(g);W=o($e,"SPAN",{});var Te=p(W);q(y.$$.fragment,Te),Te.forEach(t),$e.forEach(t),ae=i(ee),E=o(ee,"SPAN",{"data-svelte-h":!0}),I(E)!=="svelte-1bbsn14"&&(E.textContent=ve),ee.forEach(t),K=i(e),r=o(e,"DIV",{class:!0});var l=p(r);q(M.$$.fragment,l),ie=i(l),P=o(l,"P",{"data-svelte-h":!0}),I(P)!=="svelte-1ulcci3"&&(P.innerHTML=be),de=i(l),F=o(l,"P",{"data-svelte-h":!0}),I(F)!=="svelte-linuuh"&&(F.innerHTML=De),ce=i(l),v=o(l,"DIV",{class:!0});var te=p(v);q($.$$.fragment,te),le=i(te),L=o(te,"P",{"data-svelte-h":!0}),I(L)!=="svelte-1rkfgpx"&&(L.textContent=Ie),te.forEach(t),pe=i(l),b=o(l,"DIV",{class:!0});var se=p(b);q(T.$$.fragment,se),ue=i(se),N=o(se,"P",{"data-svelte-h":!0}),I(N)!=="svelte-1vzm9q"&&(N.textContent=xe),se.forEach(t),he=i(l),D=o(l,"DIV",{class:!0});var ne=p(D);q(w.$$.fragment,ne),fe=i(ne),k=o(ne,"P",{"data-svelte-h":!0}),I(k)!=="svelte-hi84tp"&&(k.textContent=Se),ne.forEach(t),l.forEach(t),Q=i(e),J=o(e,"P",{}),p(J).forEach(t),this.h()},h(){c(h,"name","hf:doc:metadata"),c(h,"content",JSON.stringify(Ae)),c(_,"id","ddiminversescheduler"),c(_,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(_,"href","#ddiminversescheduler"),c(f,"class","relative group"),c(g,"id","diffusers.DDIMInverseScheduler"),c(g,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(g,"href","#diffusers.DDIMInverseScheduler"),c(m,"class","relative group"),c(v,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(b,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(D,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(r,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,d){s(document.head,h),u(e,j,d),u(e,R,d),u(e,G,d),u(e,f,d),s(f,_),s(_,U),H(x,U,null),s(f,re),s(f,C),u(e,Y,d),u(e,S,d),u(e,B,d),u(e,m,d),s(m,g),s(g,W),H(y,W,null),s(m,ae),s(m,E),u(e,K,d),u(e,r,d),H(M,r,null),s(r,ie),s(r,P),s(r,de),s(r,F),s(r,ce),s(r,v),H($,v,null),s(v,le),s(v,L),s(r,pe),s(r,b),H(T,b,null),s(b,ue),s(b,N),s(r,he),s(r,D),H(w,D,null),s(D,fe),s(D,k),u(e,Q,d),u(e,J,d),X=!0},p:Ee,i(e){X||(z(x.$$.fragment,e),z(y.$$.fragment,e),z(M.$$.fragment,e),z($.$$.fragment,e),z(T.$$.fragment,e),z(w.$$.fragment,e),X=!0)},o(e){O(x.$$.fragment,e),O(y.$$.fragment,e),O(M.$$.fragment,e),O($.$$.fragment,e),O(T.$$.fragment,e),O(w.$$.fragment,e),X=!1},d(e){e&&(t(j),t(R),t(G),t(f),t(Y),t(S),t(B),t(m),t(K),t(r),t(Q),t(J)),t(h),V(x),V(y),V(M),V($),V(T),V(w)}}}const Ae={local:"ddiminversescheduler",sections:[{local:"diffusers.DDIMInverseScheduler",title:"DDIMInverseScheduler"}],title:"DDIMInverseScheduler"};function qe(me){return Pe(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Re extends Fe{constructor(h){super(),Le(this,h,qe,ke,Ce,{})}}export{Re as component};
