import{s as Ze,n as et,o as tt}from"../chunks/scheduler.182ea377.js";import{S as st,i as nt,g as n,s as a,u as M,A as ot,h as o,f as t,c as i,j as p,v as $,y as h,k as l,o as s,a as d,w,d as T,t as C,x as O}from"../chunks/index.caaccc80.js";import{D as se}from"../chunks/Docstring.835fbd1d.js";import{I as Ee}from"../chunks/IconCopyLink.3458bfff.js";function rt(Ae){let m,ne,Q,oe,f,D,X,L,xe,U,qe="DDPMScheduler",re,N,Fe='<a href="https://huggingface.co/papers/2006.11239" rel="nofollow">Denoising Diffusion Probabilistic Models</a> (DDPM) by Jonathan Ho, Ajay Jain and Pieter Abbeel proposes a diffusion based model of the same name. In the context of the 🤗 Diffusers library, DDPM refers to the discrete denoising scheduler from the paper as well as the pipeline.',ae,E,Ie="The abstract from the paper is:",ie,A,ke="<em>We present high quality image synthesis results using diffusion probabilistic models, a class of latent variable models inspired by considerations from nonequilibrium thermodynamics. Our best results are obtained by training on a weighted variational bound designed according to a novel connection between diffusion probabilistic models and denoising score matching with Langevin dynamics, and our models naturally admit a progressive lossy decompression scheme that can be interpreted as a generalization of autoregressive decoding. On the unconditional CIFAR10 dataset, we obtain an Inception score of 9.46 and a state-of-the-art FID score of 3.17. On 256x256 LSUN, we obtain sample quality similar to ProgressiveGAN.</em>",de,g,b,Z,q,ye,J,He="DDPMScheduler",le,c,F,Pe,R,Ve="<code>DDPMScheduler</code> explores the connections between denoising score matching and Langevin dynamics sampling.",Se,W,ze=`This model inherits from <a href="/docs/diffusers/main/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a> and <a href="/docs/diffusers/main/en/api/configuration#diffusers.ConfigMixin">ConfigMixin</a>. Check the superclass documentation for the generic
methods the library implements for all schedulers such as loading and saving.`,Me,x,I,$e,j,Ue=`Ensures interchangeability with schedulers that need to scale the denoising model input depending on the
current timestep.`,we,y,k,Te,G,Je="Sets the discrete timesteps used for the diffusion chain (to be run before inference).",Ce,P,H,Oe,Y,Re=`Predict the sample from the previous timestep by reversing the SDE. This function propagates the diffusion
process from the learned model outputs (most often the predicted noise).`,ce,_,S,ee,V,Le,B,We="DDPMSchedulerOutput",pe,v,z,Ne,K,je="Output class for the scheduler’s <code>step</code> function output.",ue,te,he;return L=new Ee({}),q=new Ee({}),F=new se({props:{name:"class diffusers.DDPMScheduler",anchor:"diffusers.DDPMScheduler",parameters:[{name:"num_train_timesteps",val:": int = 1000"},{name:"beta_start",val:": float = 0.0001"},{name:"beta_end",val:": float = 0.02"},{name:"beta_schedule",val:": str = 'linear'"},{name:"trained_betas",val:": typing.Union[numpy.ndarray, typing.List[float], NoneType] = None"},{name:"variance_type",val:": str = 'fixed_small'"},{name:"clip_sample",val:": bool = True"},{name:"prediction_type",val:": str = 'epsilon'"},{name:"thresholding",val:": bool = False"},{name:"dynamic_thresholding_ratio",val:": float = 0.995"},{name:"clip_sample_range",val:": float = 1.0"},{name:"sample_max_value",val:": float = 1.0"},{name:"timestep_spacing",val:": str = 'leading'"},{name:"steps_offset",val:": int = 0"}],parametersDescription:[{anchor:"diffusers.DDPMScheduler.num_train_timesteps",description:`<strong>num_train_timesteps</strong> (<code>int</code>, defaults to 1000) &#x2014;
The number of diffusion steps to train the model.`,name:"num_train_timesteps"},{anchor:"diffusers.DDPMScheduler.beta_start",description:`<strong>beta_start</strong> (<code>float</code>, defaults to 0.0001) &#x2014;
The starting <code>beta</code> value of inference.`,name:"beta_start"},{anchor:"diffusers.DDPMScheduler.beta_end",description:`<strong>beta_end</strong> (<code>float</code>, defaults to 0.02) &#x2014;
The final <code>beta</code> value.`,name:"beta_end"},{anchor:"diffusers.DDPMScheduler.beta_schedule",description:`<strong>beta_schedule</strong> (<code>str</code>, defaults to <code>&quot;linear&quot;</code>) &#x2014;
The beta schedule, a mapping from a beta range to a sequence of betas for stepping the model. Choose from
<code>linear</code>, <code>scaled_linear</code>, or <code>squaredcos_cap_v2</code>.`,name:"beta_schedule"},{anchor:"diffusers.DDPMScheduler.variance_type",description:`<strong>variance_type</strong> (<code>str</code>, defaults to <code>&quot;fixed_small&quot;</code>) &#x2014;
Clip the variance when adding noise to the denoised sample. Choose from <code>fixed_small</code>, <code>fixed_small_log</code>,
<code>fixed_large</code>, <code>fixed_large_log</code>, <code>learned</code> or <code>learned_range</code>.`,name:"variance_type"},{anchor:"diffusers.DDPMScheduler.clip_sample",description:`<strong>clip_sample</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Clip the predicted sample for numerical stability.`,name:"clip_sample"},{anchor:"diffusers.DDPMScheduler.clip_sample_range",description:`<strong>clip_sample_range</strong> (<code>float</code>, defaults to 1.0) &#x2014;
The maximum magnitude for sample clipping. Valid only when <code>clip_sample=True</code>.`,name:"clip_sample_range"},{anchor:"diffusers.DDPMScheduler.prediction_type",description:`<strong>prediction_type</strong> (<code>str</code>, defaults to <code>epsilon</code>, <em>optional</em>) &#x2014;
Prediction type of the scheduler function; can be <code>epsilon</code> (predicts the noise of the diffusion process),
<code>sample</code> (directly predicts the noisy sample<code>) or </code>v_prediction\` (see section 2.4 of <a href="https://imagen.research.google/video/paper.pdf" rel="nofollow">Imagen
Video</a> paper).`,name:"prediction_type"},{anchor:"diffusers.DDPMScheduler.thresholding",description:`<strong>thresholding</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to use the &#x201C;dynamic thresholding&#x201D; method. This is unsuitable for latent-space diffusion models such
as Stable Diffusion.`,name:"thresholding"},{anchor:"diffusers.DDPMScheduler.dynamic_thresholding_ratio",description:`<strong>dynamic_thresholding_ratio</strong> (<code>float</code>, defaults to 0.995) &#x2014;
The ratio for the dynamic thresholding method. Valid only when <code>thresholding=True</code>.`,name:"dynamic_thresholding_ratio"},{anchor:"diffusers.DDPMScheduler.sample_max_value",description:`<strong>sample_max_value</strong> (<code>float</code>, defaults to 1.0) &#x2014;
The threshold value for dynamic thresholding. Valid only when <code>thresholding=True</code>.`,name:"sample_max_value"},{anchor:"diffusers.DDPMScheduler.timestep_spacing",description:`<strong>timestep_spacing</strong> (<code>str</code>, defaults to <code>&quot;leading&quot;</code>) &#x2014;
The way the timesteps should be scaled. Refer to Table 2 of the <a href="https://huggingface.co/papers/2305.08891" rel="nofollow">Common Diffusion Noise Schedules and
Sample Steps are Flawed</a> for more information.`,name:"timestep_spacing"},{anchor:"diffusers.DDPMScheduler.steps_offset",description:`<strong>steps_offset</strong> (<code>int</code>, defaults to 0) &#x2014;
An offset added to the inference steps. You can use a combination of <code>offset=1</code> and
<code>set_alpha_to_one=False</code> to make the last step use step 0 for the previous alpha product like in Stable
Diffusion.`,name:"steps_offset"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_ddpm.py#L92"}}),I=new se({props:{name:"scale_model_input",anchor:"diffusers.DDPMScheduler.scale_model_input",parameters:[{name:"sample",val:": FloatTensor"},{name:"timestep",val:": typing.Optional[int] = None"}],parametersDescription:[{anchor:"diffusers.DDPMScheduler.scale_model_input.sample",description:`<strong>sample</strong> (<code>torch.FloatTensor</code>) &#x2014;
The input sample.`,name:"sample"},{anchor:"diffusers.DDPMScheduler.scale_model_input.timestep",description:`<strong>timestep</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The current timestep in the diffusion chain.`,name:"timestep"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_ddpm.py#L190",returnDescription:`
<p>A scaled input sample.</p>
`,returnType:`
<p><code>torch.FloatTensor</code></p>
`}}),k=new se({props:{name:"set_timesteps",anchor:"diffusers.DDPMScheduler.set_timesteps",parameters:[{name:"num_inference_steps",val:": typing.Optional[int] = None"},{name:"device",val:": typing.Union[str, torch.device] = None"},{name:"timesteps",val:": typing.Optional[typing.List[int]] = None"}],parametersDescription:[{anchor:"diffusers.DDPMScheduler.set_timesteps.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>) &#x2014;
The number of diffusion steps used when generating samples with a pre-trained model. If used,
<code>timesteps</code> must be <code>None</code>.`,name:"num_inference_steps"},{anchor:"diffusers.DDPMScheduler.set_timesteps.device",description:`<strong>device</strong> (<code>str</code> or <code>torch.device</code>, <em>optional</em>) &#x2014;
The device to which the timesteps should be moved to. If <code>None</code>, the timesteps are not moved.`,name:"device"},{anchor:"diffusers.DDPMScheduler.set_timesteps.timesteps",description:`<strong>timesteps</strong> (<code>List[int]</code>, <em>optional</em>) &#x2014;
Custom timesteps used to support arbitrary spacing between timesteps. If <code>None</code>, then the default
timestep spacing strategy of equal spacing between timesteps is used. If <code>timesteps</code> is passed,
<code>num_inference_steps</code> must be <code>None</code>.`,name:"timesteps"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_ddpm.py#L207"}}),H=new se({props:{name:"step",anchor:"diffusers.DDPMScheduler.step",parameters:[{name:"model_output",val:": FloatTensor"},{name:"timestep",val:": int"},{name:"sample",val:": FloatTensor"},{name:"generator",val:" = None"},{name:"return_dict",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.DDPMScheduler.step.model_output",description:`<strong>model_output</strong> (<code>torch.FloatTensor</code>) &#x2014;
The direct output from learned diffusion model.`,name:"model_output"},{anchor:"diffusers.DDPMScheduler.step.timestep",description:`<strong>timestep</strong> (<code>float</code>) &#x2014;
The current discrete timestep in the diffusion chain.`,name:"timestep"},{anchor:"diffusers.DDPMScheduler.step.sample",description:`<strong>sample</strong> (<code>torch.FloatTensor</code>) &#x2014;
A current instance of a sample created by the diffusion process.`,name:"sample"},{anchor:"diffusers.DDPMScheduler.step.generator",description:`<strong>generator</strong> (<code>torch.Generator</code>, <em>optional</em>) &#x2014;
A random number generator.`,name:"generator"},{anchor:"diffusers.DDPMScheduler.step.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/main/en/api/schedulers/ddpm#diffusers.schedulers.scheduling_ddpm.DDPMSchedulerOutput">DDPMSchedulerOutput</a> or <code>tuple</code>.`,name:"return_dict"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_ddpm.py#L356",returnDescription:`
<p>If return_dict is <code>True</code>, <a
  href="/docs/diffusers/main/en/api/schedulers/ddpm#diffusers.schedulers.scheduling_ddpm.DDPMSchedulerOutput"
>DDPMSchedulerOutput</a> is returned, otherwise a
tuple is returned where the first element is the sample tensor.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/main/en/api/schedulers/ddpm#diffusers.schedulers.scheduling_ddpm.DDPMSchedulerOutput"
>DDPMSchedulerOutput</a> or <code>tuple</code></p>
`}}),V=new Ee({}),z=new se({props:{name:"class diffusers.schedulers.scheduling_ddpm.DDPMSchedulerOutput",anchor:"diffusers.schedulers.scheduling_ddpm.DDPMSchedulerOutput",parameters:[{name:"prev_sample",val:": FloatTensor"},{name:"pred_original_sample",val:": typing.Optional[torch.FloatTensor] = None"}],parametersDescription:[{anchor:"diffusers.schedulers.scheduling_ddpm.DDPMSchedulerOutput.prev_sample",description:`<strong>prev_sample</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code> for images) &#x2014;
Computed sample <code>(x_{t-1})</code> of previous timestep. <code>prev_sample</code> should be used as next model input in the
denoising loop.`,name:"prev_sample"},{anchor:"diffusers.schedulers.scheduling_ddpm.DDPMSchedulerOutput.pred_original_sample",description:`<strong>pred_original_sample</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code> for images) &#x2014;
The predicted denoised sample <code>(x_{0})</code> based on the model output from the current timestep.
<code>pred_original_sample</code> can be used to preview progress or for guidance.`,name:"pred_original_sample"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_ddpm.py#L31"}}),{c(){m=n("meta"),ne=a(),Q=n("p"),oe=a(),f=n("h1"),D=n("a"),X=n("span"),M(L.$$.fragment),xe=a(),U=n("span"),U.textContent=qe,re=a(),N=n("p"),N.innerHTML=Fe,ae=a(),E=n("p"),E.textContent=Ie,ie=a(),A=n("p"),A.innerHTML=ke,de=a(),g=n("h2"),b=n("a"),Z=n("span"),M(q.$$.fragment),ye=a(),J=n("span"),J.textContent=He,le=a(),c=n("div"),M(F.$$.fragment),Pe=a(),R=n("p"),R.innerHTML=Ve,Se=a(),W=n("p"),W.innerHTML=ze,Me=a(),x=n("div"),M(I.$$.fragment),$e=a(),j=n("p"),j.textContent=Ue,we=a(),y=n("div"),M(k.$$.fragment),Te=a(),G=n("p"),G.textContent=Je,Ce=a(),P=n("div"),M(H.$$.fragment),Oe=a(),Y=n("p"),Y.textContent=Re,ce=a(),_=n("h2"),S=n("a"),ee=n("span"),M(V.$$.fragment),Le=a(),B=n("span"),B.textContent=We,pe=a(),v=n("div"),M(z.$$.fragment),Ne=a(),K=n("p"),K.innerHTML=je,ue=a(),te=n("p"),this.h()},l(e){const r=ot("svelte-1phssyn",document.head);m=o(r,"META",{name:!0,content:!0}),r.forEach(t),ne=i(e),Q=o(e,"P",{}),p(Q).forEach(t),oe=i(e),f=o(e,"H1",{class:!0});var me=p(f);D=o(me,"A",{id:!0,class:!0,href:!0});var Ge=p(D);X=o(Ge,"SPAN",{});var Ye=p(X);$(L.$$.fragment,Ye),Ye.forEach(t),Ge.forEach(t),xe=i(me),U=o(me,"SPAN",{"data-svelte-h":!0}),h(U)!=="svelte-lqeruf"&&(U.textContent=qe),me.forEach(t),re=i(e),N=o(e,"P",{"data-svelte-h":!0}),h(N)!=="svelte-18lgwlw"&&(N.innerHTML=Fe),ae=i(e),E=o(e,"P",{"data-svelte-h":!0}),h(E)!=="svelte-1cwsb16"&&(E.textContent=Ie),ie=i(e),A=o(e,"P",{"data-svelte-h":!0}),h(A)!=="svelte-lc79cq"&&(A.innerHTML=ke),de=i(e),g=o(e,"H2",{class:!0});var fe=p(g);b=o(fe,"A",{id:!0,class:!0,href:!0});var Be=p(b);Z=o(Be,"SPAN",{});var Ke=p(Z);$(q.$$.fragment,Ke),Ke.forEach(t),Be.forEach(t),ye=i(fe),J=o(fe,"SPAN",{"data-svelte-h":!0}),h(J)!=="svelte-lqeruf"&&(J.textContent=He),fe.forEach(t),le=i(e),c=o(e,"DIV",{class:!0});var u=p(c);$(F.$$.fragment,u),Pe=i(u),R=o(u,"P",{"data-svelte-h":!0}),h(R)!=="svelte-s0ec9y"&&(R.innerHTML=Ve),Se=i(u),W=o(u,"P",{"data-svelte-h":!0}),h(W)!=="svelte-linuuh"&&(W.innerHTML=ze),Me=i(u),x=o(u,"DIV",{class:!0});var ge=p(x);$(I.$$.fragment,ge),$e=i(ge),j=o(ge,"P",{"data-svelte-h":!0}),h(j)!=="svelte-1rkfgpx"&&(j.textContent=Ue),ge.forEach(t),we=i(u),y=o(u,"DIV",{class:!0});var _e=p(y);$(k.$$.fragment,_e),Te=i(_e),G=o(_e,"P",{"data-svelte-h":!0}),h(G)!=="svelte-1vzm9q"&&(G.textContent=Je),_e.forEach(t),Ce=i(u),P=o(u,"DIV",{class:!0});var ve=p(P);$(H.$$.fragment,ve),Oe=i(ve),Y=o(ve,"P",{"data-svelte-h":!0}),h(Y)!=="svelte-hi84tp"&&(Y.textContent=Re),ve.forEach(t),u.forEach(t),ce=i(e),_=o(e,"H2",{class:!0});var De=p(_);S=o(De,"A",{id:!0,class:!0,href:!0});var Qe=p(S);ee=o(Qe,"SPAN",{});var Xe=p(ee);$(V.$$.fragment,Xe),Xe.forEach(t),Qe.forEach(t),Le=i(De),B=o(De,"SPAN",{"data-svelte-h":!0}),h(B)!=="svelte-9osz46"&&(B.textContent=We),De.forEach(t),pe=i(e),v=o(e,"DIV",{class:!0});var be=p(v);$(z.$$.fragment,be),Ne=i(be),K=o(be,"P",{"data-svelte-h":!0}),h(K)!=="svelte-id9kic"&&(K.innerHTML=je),be.forEach(t),ue=i(e),te=o(e,"P",{}),p(te).forEach(t),this.h()},h(){l(m,"name","hf:doc:metadata"),l(m,"content",JSON.stringify(at)),l(D,"id","ddpmscheduler"),l(D,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(D,"href","#ddpmscheduler"),l(f,"class","relative group"),l(b,"id","diffusers.DDPMScheduler"),l(b,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(b,"href","#diffusers.DDPMScheduler"),l(g,"class","relative group"),l(x,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(P,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(c,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(S,"id","diffusers.schedulers.scheduling_ddpm.DDPMSchedulerOutput"),l(S,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(S,"href","#diffusers.schedulers.scheduling_ddpm.DDPMSchedulerOutput"),l(_,"class","relative group"),l(v,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,r){s(document.head,m),d(e,ne,r),d(e,Q,r),d(e,oe,r),d(e,f,r),s(f,D),s(D,X),w(L,X,null),s(f,xe),s(f,U),d(e,re,r),d(e,N,r),d(e,ae,r),d(e,E,r),d(e,ie,r),d(e,A,r),d(e,de,r),d(e,g,r),s(g,b),s(b,Z),w(q,Z,null),s(g,ye),s(g,J),d(e,le,r),d(e,c,r),w(F,c,null),s(c,Pe),s(c,R),s(c,Se),s(c,W),s(c,Me),s(c,x),w(I,x,null),s(x,$e),s(x,j),s(c,we),s(c,y),w(k,y,null),s(y,Te),s(y,G),s(c,Ce),s(c,P),w(H,P,null),s(P,Oe),s(P,Y),d(e,ce,r),d(e,_,r),s(_,S),s(S,ee),w(V,ee,null),s(_,Le),s(_,B),d(e,pe,r),d(e,v,r),w(z,v,null),s(v,Ne),s(v,K),d(e,ue,r),d(e,te,r),he=!0},p:et,i(e){he||(T(L.$$.fragment,e),T(q.$$.fragment,e),T(F.$$.fragment,e),T(I.$$.fragment,e),T(k.$$.fragment,e),T(H.$$.fragment,e),T(V.$$.fragment,e),T(z.$$.fragment,e),he=!0)},o(e){C(L.$$.fragment,e),C(q.$$.fragment,e),C(F.$$.fragment,e),C(I.$$.fragment,e),C(k.$$.fragment,e),C(H.$$.fragment,e),C(V.$$.fragment,e),C(z.$$.fragment,e),he=!1},d(e){e&&(t(ne),t(Q),t(oe),t(f),t(re),t(N),t(ae),t(E),t(ie),t(A),t(de),t(g),t(le),t(c),t(ce),t(_),t(pe),t(v),t(ue),t(te)),t(m),O(L),O(q),O(F),O(I),O(k),O(H),O(V),O(z)}}}const at={local:"ddpmscheduler",sections:[{local:"diffusers.DDPMScheduler",title:"DDPMScheduler"},{local:"diffusers.schedulers.scheduling_ddpm.DDPMSchedulerOutput",title:"DDPMSchedulerOutput"}],title:"DDPMScheduler"};function it(Ae){return tt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ut extends st{constructor(m){super(),nt(this,m,it,rt,Ze,{})}}export{ut as component};
