import{s as Ye,n as Qe,o as Xe}from"../chunks/scheduler.182ea377.js";import{S as Ze,i as et,g as r,s as i,u as P,A as tt,h as n,f as t,c as a,j as u,v as w,y as h,k as d,o as s,a as c,w as M,d as T,t as C,x as K}from"../chunks/index.caaccc80.js";import{D as te}from"../chunks/Docstring.835fbd1d.js";import{I as ke}from"../chunks/IconCopyLink.3458bfff.js";function st(Ee){let f,se,Y,re,m,b,Q,k,be,U,Le="KDPM2DiscreteScheduler",ne,E,Oe='The <code>KDPM2DiscreteScheduler</code> is inspired by the <a href="https://huggingface.co/papers/2206.00364" rel="nofollow">Elucidating the Design Space of Diffusion-Based Generative Models</a> paper, and the scheduler is ported from and created by <a href="https://github.com/crowsonkb/" rel="nofollow">Katherine Crowson</a>.',oe,L,Ae='The original codebase can be found at <a href="https://github.com/crowsonkb/k-diffusion" rel="nofollow">crowsonkb/k-diffusion</a>.',ie,g,D,X,O,De,V,Fe="KDPM2DiscreteScheduler",ae,l,A,Se,z,He=`KDPM2DiscreteScheduler is inspired by the DPMSolver2 and Algorithm 2 from the <a href="https://huggingface.co/papers/2206.00364" rel="nofollow">Elucidating the Design Space of
Diffusion-Based Generative Models</a> paper.`,$e,B,Ne=`This model inherits from <a href="/docs/diffusers/main/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a> and <a href="/docs/diffusers/main/en/api/configuration#diffusers.ConfigMixin">ConfigMixin</a>. Check the superclass documentation for the generic
methods the library implements for all schedulers such as loading and saving.`,ye,S,F,xe,j,Ie=`Ensures interchangeability with schedulers that need to scale the denoising model input depending on the
current timestep.`,Pe,$,H,we,G,qe="Sets the discrete timesteps used for the diffusion chain (to be run before inference).",Me,y,N,Te,R,Ue=`Predict the sample from the previous timestep by reversing the SDE. This function propagates the diffusion
process from the learned model outputs (most often the predicted noise).`,de,_,x,Z,I,Ce,W,Ve="SchedulerOutput",ce,v,q,Ke,J,ze="Base class for the output of a scheduler’s <code>step</code> function.",le,ee,ue;return k=new ke({}),O=new ke({}),A=new te({props:{name:"class diffusers.KDPM2DiscreteScheduler",anchor:"diffusers.KDPM2DiscreteScheduler",parameters:[{name:"num_train_timesteps",val:": int = 1000"},{name:"beta_start",val:": float = 0.00085"},{name:"beta_end",val:": float = 0.012"},{name:"beta_schedule",val:": str = 'linear'"},{name:"trained_betas",val:": typing.Union[numpy.ndarray, typing.List[float], NoneType] = None"},{name:"use_karras_sigmas",val:": typing.Optional[bool] = False"},{name:"prediction_type",val:": str = 'epsilon'"},{name:"timestep_spacing",val:": str = 'linspace'"},{name:"steps_offset",val:": int = 0"}],parametersDescription:[{anchor:"diffusers.KDPM2DiscreteScheduler.num_train_timesteps",description:`<strong>num_train_timesteps</strong> (<code>int</code>, defaults to 1000) &#x2014;
The number of diffusion steps to train the model.`,name:"num_train_timesteps"},{anchor:"diffusers.KDPM2DiscreteScheduler.beta_start",description:`<strong>beta_start</strong> (<code>float</code>, defaults to 0.00085) &#x2014;
The starting <code>beta</code> value of inference.`,name:"beta_start"},{anchor:"diffusers.KDPM2DiscreteScheduler.beta_end",description:`<strong>beta_end</strong> (<code>float</code>, defaults to 0.012) &#x2014;
The final <code>beta</code> value.`,name:"beta_end"},{anchor:"diffusers.KDPM2DiscreteScheduler.beta_schedule",description:`<strong>beta_schedule</strong> (<code>str</code>, defaults to <code>&quot;linear&quot;</code>) &#x2014;
The beta schedule, a mapping from a beta range to a sequence of betas for stepping the model. Choose from
<code>linear</code> or <code>scaled_linear</code>.`,name:"beta_schedule"},{anchor:"diffusers.KDPM2DiscreteScheduler.trained_betas",description:`<strong>trained_betas</strong> (<code>np.ndarray</code>, <em>optional</em>) &#x2014;
Pass an array of betas directly to the constructor to bypass <code>beta_start</code> and <code>beta_end</code>.`,name:"trained_betas"},{anchor:"diffusers.KDPM2DiscreteScheduler.use_karras_sigmas",description:`<strong>use_karras_sigmas</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to use Karras sigmas for step sizes in the noise schedule during the sampling process. If <code>True</code>,
the sigmas are determined according to a sequence of noise levels {&#x3C3;i}.`,name:"use_karras_sigmas"},{anchor:"diffusers.KDPM2DiscreteScheduler.prediction_type",description:`<strong>prediction_type</strong> (<code>str</code>, defaults to <code>epsilon</code>, <em>optional</em>) &#x2014;
Prediction type of the scheduler function; can be <code>epsilon</code> (predicts the noise of the diffusion process),
<code>sample</code> (directly predicts the noisy sample<code>) or </code>v_prediction\` (see section 2.4 of <a href="https://imagen.research.google/video/paper.pdf" rel="nofollow">Imagen
Video</a> paper).`,name:"prediction_type"},{anchor:"diffusers.KDPM2DiscreteScheduler.timestep_spacing",description:`<strong>timestep_spacing</strong> (<code>str</code>, defaults to <code>&quot;linspace&quot;</code>) &#x2014;
The way the timesteps should be scaled. Refer to Table 2 of the <a href="https://huggingface.co/papers/2305.08891" rel="nofollow">Common Diffusion Noise Schedules and
Sample Steps are Flawed</a> for more information.`,name:"timestep_spacing"},{anchor:"diffusers.KDPM2DiscreteScheduler.steps_offset",description:`<strong>steps_offset</strong> (<code>int</code>, defaults to 0) &#x2014;
An offset added to the inference steps. You can use a combination of <code>offset=1</code> and
<code>set_alpha_to_one=False</code> to make the last step use step 0 for the previous alpha product like in Stable
Diffusion.`,name:"steps_offset"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_k_dpm_2_discrete.py#L71"}}),F=new te({props:{name:"scale_model_input",anchor:"diffusers.KDPM2DiscreteScheduler.scale_model_input",parameters:[{name:"sample",val:": FloatTensor"},{name:"timestep",val:": typing.Union[float, torch.FloatTensor]"}],parametersDescription:[{anchor:"diffusers.KDPM2DiscreteScheduler.scale_model_input.sample",description:`<strong>sample</strong> (<code>torch.FloatTensor</code>) &#x2014;
The input sample.`,name:"sample"},{anchor:"diffusers.KDPM2DiscreteScheduler.scale_model_input.timestep",description:`<strong>timestep</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The current timestep in the diffusion chain.`,name:"timestep"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_k_dpm_2_discrete.py#L180",returnDescription:`
<p>A scaled input sample.</p>
`,returnType:`
<p><code>torch.FloatTensor</code></p>
`}}),H=new te({props:{name:"set_timesteps",anchor:"diffusers.KDPM2DiscreteScheduler.set_timesteps",parameters:[{name:"num_inference_steps",val:": int"},{name:"device",val:": typing.Union[str, torch.device] = None"},{name:"num_train_timesteps",val:": typing.Optional[int] = None"}],parametersDescription:[{anchor:"diffusers.KDPM2DiscreteScheduler.set_timesteps.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>) &#x2014;
The number of diffusion steps used when generating samples with a pre-trained model.`,name:"num_inference_steps"},{anchor:"diffusers.KDPM2DiscreteScheduler.set_timesteps.device",description:`<strong>device</strong> (<code>str</code> or <code>torch.device</code>, <em>optional</em>) &#x2014;
The device to which the timesteps should be moved to. If <code>None</code>, the timesteps are not moved.`,name:"device"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_k_dpm_2_discrete.py#L210"}}),N=new te({props:{name:"step",anchor:"diffusers.KDPM2DiscreteScheduler.step",parameters:[{name:"model_output",val:": typing.Union[torch.FloatTensor, numpy.ndarray]"},{name:"timestep",val:": typing.Union[float, torch.FloatTensor]"},{name:"sample",val:": typing.Union[torch.FloatTensor, numpy.ndarray]"},{name:"return_dict",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.KDPM2DiscreteScheduler.step.model_output",description:`<strong>model_output</strong> (<code>torch.FloatTensor</code>) &#x2014;
The direct output from learned diffusion model.`,name:"model_output"},{anchor:"diffusers.KDPM2DiscreteScheduler.step.timestep",description:`<strong>timestep</strong> (<code>float</code>) &#x2014;
The current discrete timestep in the diffusion chain.`,name:"timestep"},{anchor:"diffusers.KDPM2DiscreteScheduler.step.sample",description:`<strong>sample</strong> (<code>torch.FloatTensor</code>) &#x2014;
A current instance of a sample created by the diffusion process.`,name:"sample"},{anchor:"diffusers.KDPM2DiscreteScheduler.step.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/main/en/api/schedulers/singlestep_dpm_solver#diffusers.schedulers.scheduling_utils.SchedulerOutput">SchedulerOutput</a> or tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_k_dpm_2_discrete.py#L350",returnDescription:`
<p>If return_dict is <code>True</code>, <a
  href="/docs/diffusers/main/en/api/schedulers/singlestep_dpm_solver#diffusers.schedulers.scheduling_utils.SchedulerOutput"
>SchedulerOutput</a> is returned, otherwise a
tuple is returned where the first element is the sample tensor.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/main/en/api/schedulers/singlestep_dpm_solver#diffusers.schedulers.scheduling_utils.SchedulerOutput"
>SchedulerOutput</a> or <code>tuple</code></p>
`}}),I=new ke({}),q=new te({props:{name:"class diffusers.schedulers.scheduling_utils.SchedulerOutput",anchor:"diffusers.schedulers.scheduling_utils.SchedulerOutput",parameters:[{name:"prev_sample",val:": FloatTensor"}],parametersDescription:[{anchor:"diffusers.schedulers.scheduling_utils.SchedulerOutput.prev_sample",description:`<strong>prev_sample</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code> for images) &#x2014;
Computed sample <code>(x_{t-1})</code> of previous timestep. <code>prev_sample</code> should be used as next model input in the
denoising loop.`,name:"prev_sample"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_utils.py#L50"}}),{c(){f=r("meta"),se=i(),Y=r("p"),re=i(),m=r("h1"),b=r("a"),Q=r("span"),P(k.$$.fragment),be=i(),U=r("span"),U.textContent=Le,ne=i(),E=r("p"),E.innerHTML=Oe,oe=i(),L=r("p"),L.innerHTML=Ae,ie=i(),g=r("h2"),D=r("a"),X=r("span"),P(O.$$.fragment),De=i(),V=r("span"),V.textContent=Fe,ae=i(),l=r("div"),P(A.$$.fragment),Se=i(),z=r("p"),z.innerHTML=He,$e=i(),B=r("p"),B.innerHTML=Ne,ye=i(),S=r("div"),P(F.$$.fragment),xe=i(),j=r("p"),j.textContent=Ie,Pe=i(),$=r("div"),P(H.$$.fragment),we=i(),G=r("p"),G.textContent=qe,Me=i(),y=r("div"),P(N.$$.fragment),Te=i(),R=r("p"),R.textContent=Ue,de=i(),_=r("h2"),x=r("a"),Z=r("span"),P(I.$$.fragment),Ce=i(),W=r("span"),W.textContent=Ve,ce=i(),v=r("div"),P(q.$$.fragment),Ke=i(),J=r("p"),J.innerHTML=ze,le=i(),ee=r("p"),this.h()},l(e){const o=tt("svelte-1phssyn",document.head);f=n(o,"META",{name:!0,content:!0}),o.forEach(t),se=a(e),Y=n(e,"P",{}),u(Y).forEach(t),re=a(e),m=n(e,"H1",{class:!0});var pe=u(m);b=n(pe,"A",{id:!0,class:!0,href:!0});var Be=u(b);Q=n(Be,"SPAN",{});var je=u(Q);w(k.$$.fragment,je),je.forEach(t),Be.forEach(t),be=a(pe),U=n(pe,"SPAN",{"data-svelte-h":!0}),h(U)!=="svelte-hsoho3"&&(U.textContent=Le),pe.forEach(t),ne=a(e),E=n(e,"P",{"data-svelte-h":!0}),h(E)!=="svelte-1r1y5wx"&&(E.innerHTML=Oe),oe=a(e),L=n(e,"P",{"data-svelte-h":!0}),h(L)!=="svelte-loovl7"&&(L.innerHTML=Ae),ie=a(e),g=n(e,"H2",{class:!0});var he=u(g);D=n(he,"A",{id:!0,class:!0,href:!0});var Ge=u(D);X=n(Ge,"SPAN",{});var Re=u(X);w(O.$$.fragment,Re),Re.forEach(t),Ge.forEach(t),De=a(he),V=n(he,"SPAN",{"data-svelte-h":!0}),h(V)!=="svelte-hsoho3"&&(V.textContent=Fe),he.forEach(t),ae=a(e),l=n(e,"DIV",{class:!0});var p=u(l);w(A.$$.fragment,p),Se=a(p),z=n(p,"P",{"data-svelte-h":!0}),h(z)!=="svelte-iytw69"&&(z.innerHTML=He),$e=a(p),B=n(p,"P",{"data-svelte-h":!0}),h(B)!=="svelte-linuuh"&&(B.innerHTML=Ne),ye=a(p),S=n(p,"DIV",{class:!0});var fe=u(S);w(F.$$.fragment,fe),xe=a(fe),j=n(fe,"P",{"data-svelte-h":!0}),h(j)!=="svelte-1rkfgpx"&&(j.textContent=Ie),fe.forEach(t),Pe=a(p),$=n(p,"DIV",{class:!0});var me=u($);w(H.$$.fragment,me),we=a(me),G=n(me,"P",{"data-svelte-h":!0}),h(G)!=="svelte-1vzm9q"&&(G.textContent=qe),me.forEach(t),Me=a(p),y=n(p,"DIV",{class:!0});var ge=u(y);w(N.$$.fragment,ge),Te=a(ge),R=n(ge,"P",{"data-svelte-h":!0}),h(R)!=="svelte-hi84tp"&&(R.textContent=Ue),ge.forEach(t),p.forEach(t),de=a(e),_=n(e,"H2",{class:!0});var _e=u(_);x=n(_e,"A",{id:!0,class:!0,href:!0});var We=u(x);Z=n(We,"SPAN",{});var Je=u(Z);w(I.$$.fragment,Je),Je.forEach(t),We.forEach(t),Ce=a(_e),W=n(_e,"SPAN",{"data-svelte-h":!0}),h(W)!=="svelte-1qoi9nz"&&(W.textContent=Ve),_e.forEach(t),ce=a(e),v=n(e,"DIV",{class:!0});var ve=u(v);w(q.$$.fragment,ve),Ke=a(ve),J=n(ve,"P",{"data-svelte-h":!0}),h(J)!=="svelte-6ojmkw"&&(J.innerHTML=ze),ve.forEach(t),le=a(e),ee=n(e,"P",{}),u(ee).forEach(t),this.h()},h(){d(f,"name","hf:doc:metadata"),d(f,"content",JSON.stringify(rt)),d(b,"id","kdpm2discretescheduler"),d(b,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(b,"href","#kdpm2discretescheduler"),d(m,"class","relative group"),d(D,"id","diffusers.KDPM2DiscreteScheduler"),d(D,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(D,"href","#diffusers.KDPM2DiscreteScheduler"),d(g,"class","relative group"),d(S,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d($,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(l,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(x,"id","diffusers.schedulers.scheduling_utils.SchedulerOutput"),d(x,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(x,"href","#diffusers.schedulers.scheduling_utils.SchedulerOutput"),d(_,"class","relative group"),d(v,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,o){s(document.head,f),c(e,se,o),c(e,Y,o),c(e,re,o),c(e,m,o),s(m,b),s(b,Q),M(k,Q,null),s(m,be),s(m,U),c(e,ne,o),c(e,E,o),c(e,oe,o),c(e,L,o),c(e,ie,o),c(e,g,o),s(g,D),s(D,X),M(O,X,null),s(g,De),s(g,V),c(e,ae,o),c(e,l,o),M(A,l,null),s(l,Se),s(l,z),s(l,$e),s(l,B),s(l,ye),s(l,S),M(F,S,null),s(S,xe),s(S,j),s(l,Pe),s(l,$),M(H,$,null),s($,we),s($,G),s(l,Me),s(l,y),M(N,y,null),s(y,Te),s(y,R),c(e,de,o),c(e,_,o),s(_,x),s(x,Z),M(I,Z,null),s(_,Ce),s(_,W),c(e,ce,o),c(e,v,o),M(q,v,null),s(v,Ke),s(v,J),c(e,le,o),c(e,ee,o),ue=!0},p:Qe,i(e){ue||(T(k.$$.fragment,e),T(O.$$.fragment,e),T(A.$$.fragment,e),T(F.$$.fragment,e),T(H.$$.fragment,e),T(N.$$.fragment,e),T(I.$$.fragment,e),T(q.$$.fragment,e),ue=!0)},o(e){C(k.$$.fragment,e),C(O.$$.fragment,e),C(A.$$.fragment,e),C(F.$$.fragment,e),C(H.$$.fragment,e),C(N.$$.fragment,e),C(I.$$.fragment,e),C(q.$$.fragment,e),ue=!1},d(e){e&&(t(se),t(Y),t(re),t(m),t(ne),t(E),t(oe),t(L),t(ie),t(g),t(ae),t(l),t(de),t(_),t(ce),t(v),t(le),t(ee)),t(f),K(k),K(O),K(A),K(F),K(H),K(N),K(I),K(q)}}}const rt={local:"kdpm2discretescheduler",sections:[{local:"diffusers.KDPM2DiscreteScheduler",title:"KDPM2DiscreteScheduler"},{local:"diffusers.schedulers.scheduling_utils.SchedulerOutput",title:"SchedulerOutput"}],title:"KDPM2DiscreteScheduler"};function nt(Ee){return Xe(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ct extends Ze{constructor(f){super(),et(this,f,nt,st,Ye,{})}}export{ct as component};
