import{s as je,n as Be,o as Je}from"../chunks/scheduler.182ea377.js";import{S as Ye,i as Qe,g as s,s as o,u as y,A as Xe,h as n,f as t,c as i,j as d,v as w,y as h,k as c,o as r,a as u,w as T,d as C,t as k,x as P}from"../chunks/index.caaccc80.js";import{D as ee}from"../chunks/Docstring.835fbd1d.js";import{I as ke}from"../chunks/IconCopyLink.3458bfff.js";function Ze(Pe){let f,te,J,re,m,b,Y,O,_e,V,Oe="EulerDiscreteScheduler",se,F,Fe='The Euler scheduler (Algorithm 2) is from the <a href="https://huggingface.co/papers/2206.00364" rel="nofollow">Elucidating the Design Space of Diffusion-Based Generative Models</a> paper by Karras et al. This is a fast scheduler which can often generate good outputs in 20-30 steps. The scheduler is based on the original <a href="https://github.com/crowsonkb/k-diffusion/blob/481677d114f6ea445aa009cf5bd7a9cdee909e47/k_diffusion/sampling.py#L51" rel="nofollow">k-diffusion</a> implementation by <a href="https://github.com/crowsonkb/" rel="nofollow">Katherine Crowson</a>.',ne,g,E,Q,L,ve,U,Le="EulerDiscreteScheduler",oe,l,A,be,z,Ae="Euler scheduler.",Ee,G,qe=`This model inherits from <a href="/docs/diffusers/main/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a> and <a href="/docs/diffusers/main/en/api/configuration#diffusers.ConfigMixin">ConfigMixin</a>. Check the superclass documentation for the generic
methods the library implements for all schedulers such as loading and saving.`,Se,S,q,xe,K,Me=`Ensures interchangeability with schedulers that need to scale the denoising model input depending on the
current timestep. Scales the denoising model input by <code>(sigma**2 + 1) ** 0.5</code> to match the Euler algorithm.`,De,x,M,$e,R,Ne="Sets the discrete timesteps used for the diffusion chain (to be run before inference).",ye,D,N,we,W,He=`Predict the sample from the previous timestep by reversing the SDE. This function propagates the diffusion
process from the learned model outputs (most often the predicted noise).`,ie,_,$,X,H,Te,j,Ie="EulerDiscreteSchedulerOutput",ae,v,I,Ce,B,Ve="Output class for the scheduler’s <code>step</code> function output.",ce,Z,le;return O=new ke({}),L=new ke({}),A=new ee({props:{name:"class diffusers.EulerDiscreteScheduler",anchor:"diffusers.EulerDiscreteScheduler",parameters:[{name:"num_train_timesteps",val:": int = 1000"},{name:"beta_start",val:": float = 0.0001"},{name:"beta_end",val:": float = 0.02"},{name:"beta_schedule",val:": str = 'linear'"},{name:"trained_betas",val:": typing.Union[numpy.ndarray, typing.List[float], NoneType] = None"},{name:"prediction_type",val:": str = 'epsilon'"},{name:"interpolation_type",val:": str = 'linear'"},{name:"use_karras_sigmas",val:": typing.Optional[bool] = False"},{name:"timestep_spacing",val:": str = 'linspace'"},{name:"steps_offset",val:": int = 0"}],parametersDescription:[{anchor:"diffusers.EulerDiscreteScheduler.num_train_timesteps",description:`<strong>num_train_timesteps</strong> (<code>int</code>, defaults to 1000) &#x2014;
The number of diffusion steps to train the model.`,name:"num_train_timesteps"},{anchor:"diffusers.EulerDiscreteScheduler.beta_start",description:`<strong>beta_start</strong> (<code>float</code>, defaults to 0.0001) &#x2014;
The starting <code>beta</code> value of inference.`,name:"beta_start"},{anchor:"diffusers.EulerDiscreteScheduler.beta_end",description:`<strong>beta_end</strong> (<code>float</code>, defaults to 0.02) &#x2014;
The final <code>beta</code> value.`,name:"beta_end"},{anchor:"diffusers.EulerDiscreteScheduler.beta_schedule",description:`<strong>beta_schedule</strong> (<code>str</code>, defaults to <code>&quot;linear&quot;</code>) &#x2014;
The beta schedule, a mapping from a beta range to a sequence of betas for stepping the model. Choose from
<code>linear</code> or <code>scaled_linear</code>.`,name:"beta_schedule"},{anchor:"diffusers.EulerDiscreteScheduler.trained_betas",description:`<strong>trained_betas</strong> (<code>np.ndarray</code>, <em>optional</em>) &#x2014;
Pass an array of betas directly to the constructor to bypass <code>beta_start</code> and <code>beta_end</code>.`,name:"trained_betas"},{anchor:"diffusers.EulerDiscreteScheduler.prediction_type",description:`<strong>prediction_type</strong> (<code>str</code>, defaults to <code>epsilon</code>, <em>optional</em>) &#x2014;
Prediction type of the scheduler function; can be <code>epsilon</code> (predicts the noise of the diffusion process),
<code>sample</code> (directly predicts the noisy sample<code>) or </code>v_prediction\` (see section 2.4 of <a href="https://imagen.research.google/video/paper.pdf" rel="nofollow">Imagen
Video</a> paper).`,name:"prediction_type"},{anchor:"diffusers.EulerDiscreteScheduler.interpolation_type(str,",description:`<strong>interpolation_type(<code>str</code>,</strong> defaults to <code>&quot;linear&quot;</code>, <em>optional</em>) &#x2014;
The interpolation type to compute intermediate sigmas for the scheduler denoising steps. Should be on of
<code>&quot;linear&quot;</code> or <code>&quot;log_linear&quot;</code>.`,name:"interpolation_type(str,"},{anchor:"diffusers.EulerDiscreteScheduler.use_karras_sigmas",description:`<strong>use_karras_sigmas</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to use Karras sigmas for step sizes in the noise schedule during the sampling process. If <code>True</code>,
the sigmas are determined according to a sequence of noise levels {&#x3C3;i}.`,name:"use_karras_sigmas"},{anchor:"diffusers.EulerDiscreteScheduler.timestep_spacing",description:`<strong>timestep_spacing</strong> (<code>str</code>, defaults to <code>&quot;linspace&quot;</code>) &#x2014;
The way the timesteps should be scaled. Refer to Table 2 of the <a href="https://huggingface.co/papers/2305.08891" rel="nofollow">Common Diffusion Noise Schedules and
Sample Steps are Flawed</a> for more information.`,name:"timestep_spacing"},{anchor:"diffusers.EulerDiscreteScheduler.steps_offset",description:`<strong>steps_offset</strong> (<code>int</code>, defaults to 0) &#x2014;
An offset added to the inference steps. You can use a combination of <code>offset=1</code> and
<code>set_alpha_to_one=False</code> to make the last step use step 0 for the previous alpha product like in Stable
Diffusion.`,name:"steps_offset"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_euler_discrete.py#L95"}}),q=new ee({props:{name:"scale_model_input",anchor:"diffusers.EulerDiscreteScheduler.scale_model_input",parameters:[{name:"sample",val:": FloatTensor"},{name:"timestep",val:": typing.Union[float, torch.FloatTensor]"}],parametersDescription:[{anchor:"diffusers.EulerDiscreteScheduler.scale_model_input.sample",description:`<strong>sample</strong> (<code>torch.FloatTensor</code>) &#x2014;
The input sample.`,name:"sample"},{anchor:"diffusers.EulerDiscreteScheduler.scale_model_input.timestep",description:`<strong>timestep</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The current timestep in the diffusion chain.`,name:"timestep"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_euler_discrete.py#L196",returnDescription:`
<p>A scaled input sample.</p>
`,returnType:`
<p><code>torch.FloatTensor</code></p>
`}}),M=new ee({props:{name:"set_timesteps",anchor:"diffusers.EulerDiscreteScheduler.set_timesteps",parameters:[{name:"num_inference_steps",val:": int"},{name:"device",val:": typing.Union[str, torch.device] = None"}],parametersDescription:[{anchor:"diffusers.EulerDiscreteScheduler.set_timesteps.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>) &#x2014;
The number of diffusion steps used when generating samples with a pre-trained model.`,name:"num_inference_steps"},{anchor:"diffusers.EulerDiscreteScheduler.set_timesteps.device",description:`<strong>device</strong> (<code>str</code> or <code>torch.device</code>, <em>optional</em>) &#x2014;
The device to which the timesteps should be moved to. If <code>None</code>, the timesteps are not moved.`,name:"device"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_euler_discrete.py#L222"}}),N=new ee({props:{name:"step",anchor:"diffusers.EulerDiscreteScheduler.step",parameters:[{name:"model_output",val:": FloatTensor"},{name:"timestep",val:": typing.Union[float, torch.FloatTensor]"},{name:"sample",val:": FloatTensor"},{name:"s_churn",val:": float = 0.0"},{name:"s_tmin",val:": float = 0.0"},{name:"s_tmax",val:": float = inf"},{name:"s_noise",val:": float = 1.0"},{name:"generator",val:": typing.Optional[torch._C.Generator] = None"},{name:"return_dict",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.EulerDiscreteScheduler.step.model_output",description:`<strong>model_output</strong> (<code>torch.FloatTensor</code>) &#x2014;
The direct output from learned diffusion model.`,name:"model_output"},{anchor:"diffusers.EulerDiscreteScheduler.step.timestep",description:`<strong>timestep</strong> (<code>float</code>) &#x2014;
The current discrete timestep in the diffusion chain.`,name:"timestep"},{anchor:"diffusers.EulerDiscreteScheduler.step.sample",description:`<strong>sample</strong> (<code>torch.FloatTensor</code>) &#x2014;
A current instance of a sample created by the diffusion process.`,name:"sample"},{anchor:"diffusers.EulerDiscreteScheduler.step.s_churn",description:"<strong>s_churn</strong> (<code>float</code>) &#x2014;",name:"s_churn"},{anchor:"diffusers.EulerDiscreteScheduler.step.s_tmin",description:"<strong>s_tmin</strong>  (<code>float</code>) &#x2014;",name:"s_tmin"},{anchor:"diffusers.EulerDiscreteScheduler.step.s_tmax",description:"<strong>s_tmax</strong>  (<code>float</code>) &#x2014;",name:"s_tmax"},{anchor:"diffusers.EulerDiscreteScheduler.step.s_noise",description:`<strong>s_noise</strong> (<code>float</code>, defaults to 1.0) &#x2014;
Scaling factor for noise added to the sample.`,name:"s_noise"},{anchor:"diffusers.EulerDiscreteScheduler.step.generator",description:`<strong>generator</strong> (<code>torch.Generator</code>, <em>optional</em>) &#x2014;
A random number generator.`,name:"generator"},{anchor:"diffusers.EulerDiscreteScheduler.step.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/main/en/api/schedulers/euler#diffusers.schedulers.scheduling_euler_discrete.EulerDiscreteSchedulerOutput">EulerDiscreteSchedulerOutput</a> or
tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_euler_discrete.py#L333",returnDescription:`
<p>If return_dict is <code>True</code>, <a
  href="/docs/diffusers/main/en/api/schedulers/euler#diffusers.schedulers.scheduling_euler_discrete.EulerDiscreteSchedulerOutput"
>EulerDiscreteSchedulerOutput</a> is
returned, otherwise a tuple is returned where the first element is the sample tensor.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/main/en/api/schedulers/euler#diffusers.schedulers.scheduling_euler_discrete.EulerDiscreteSchedulerOutput"
>EulerDiscreteSchedulerOutput</a> or <code>tuple</code></p>
`}}),H=new ke({}),I=new ee({props:{name:"class diffusers.schedulers.scheduling_euler_discrete.EulerDiscreteSchedulerOutput",anchor:"diffusers.schedulers.scheduling_euler_discrete.EulerDiscreteSchedulerOutput",parameters:[{name:"prev_sample",val:": FloatTensor"},{name:"pred_original_sample",val:": typing.Optional[torch.FloatTensor] = None"}],parametersDescription:[{anchor:"diffusers.schedulers.scheduling_euler_discrete.EulerDiscreteSchedulerOutput.prev_sample",description:`<strong>prev_sample</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code> for images) &#x2014;
Computed sample <code>(x_{t-1})</code> of previous timestep. <code>prev_sample</code> should be used as next model input in the
denoising loop.`,name:"prev_sample"},{anchor:"diffusers.schedulers.scheduling_euler_discrete.EulerDiscreteSchedulerOutput.pred_original_sample",description:`<strong>pred_original_sample</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code> for images) &#x2014;
The predicted denoised sample <code>(x_{0})</code> based on the model output from the current timestep.
<code>pred_original_sample</code> can be used to preview progress or for guidance.`,name:"pred_original_sample"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_euler_discrete.py#L33"}}),{c(){f=s("meta"),te=o(),J=s("p"),re=o(),m=s("h1"),b=s("a"),Y=s("span"),y(O.$$.fragment),_e=o(),V=s("span"),V.textContent=Oe,se=o(),F=s("p"),F.innerHTML=Fe,ne=o(),g=s("h2"),E=s("a"),Q=s("span"),y(L.$$.fragment),ve=o(),U=s("span"),U.textContent=Le,oe=o(),l=s("div"),y(A.$$.fragment),be=o(),z=s("p"),z.textContent=Ae,Ee=o(),G=s("p"),G.innerHTML=qe,Se=o(),S=s("div"),y(q.$$.fragment),xe=o(),K=s("p"),K.innerHTML=Me,De=o(),x=s("div"),y(M.$$.fragment),$e=o(),R=s("p"),R.textContent=Ne,ye=o(),D=s("div"),y(N.$$.fragment),we=o(),W=s("p"),W.textContent=He,ie=o(),_=s("h2"),$=s("a"),X=s("span"),y(H.$$.fragment),Te=o(),j=s("span"),j.textContent=Ie,ae=o(),v=s("div"),y(I.$$.fragment),Ce=o(),B=s("p"),B.innerHTML=Ve,ce=o(),Z=s("p"),this.h()},l(e){const a=Xe("svelte-1phssyn",document.head);f=n(a,"META",{name:!0,content:!0}),a.forEach(t),te=i(e),J=n(e,"P",{}),d(J).forEach(t),re=i(e),m=n(e,"H1",{class:!0});var de=d(m);b=n(de,"A",{id:!0,class:!0,href:!0});var Ue=d(b);Y=n(Ue,"SPAN",{});var ze=d(Y);w(O.$$.fragment,ze),ze.forEach(t),Ue.forEach(t),_e=i(de),V=n(de,"SPAN",{"data-svelte-h":!0}),h(V)!=="svelte-sne4t0"&&(V.textContent=Oe),de.forEach(t),se=i(e),F=n(e,"P",{"data-svelte-h":!0}),h(F)!=="svelte-1gv4s4b"&&(F.innerHTML=Fe),ne=i(e),g=n(e,"H2",{class:!0});var ue=d(g);E=n(ue,"A",{id:!0,class:!0,href:!0});var Ge=d(E);Q=n(Ge,"SPAN",{});var Ke=d(Q);w(L.$$.fragment,Ke),Ke.forEach(t),Ge.forEach(t),ve=i(ue),U=n(ue,"SPAN",{"data-svelte-h":!0}),h(U)!=="svelte-sne4t0"&&(U.textContent=Le),ue.forEach(t),oe=i(e),l=n(e,"DIV",{class:!0});var p=d(l);w(A.$$.fragment,p),be=i(p),z=n(p,"P",{"data-svelte-h":!0}),h(z)!=="svelte-rqsn3u"&&(z.textContent=Ae),Ee=i(p),G=n(p,"P",{"data-svelte-h":!0}),h(G)!=="svelte-linuuh"&&(G.innerHTML=qe),Se=i(p),S=n(p,"DIV",{class:!0});var pe=d(S);w(q.$$.fragment,pe),xe=i(pe),K=n(pe,"P",{"data-svelte-h":!0}),h(K)!=="svelte-1hew89w"&&(K.innerHTML=Me),pe.forEach(t),De=i(p),x=n(p,"DIV",{class:!0});var he=d(x);w(M.$$.fragment,he),$e=i(he),R=n(he,"P",{"data-svelte-h":!0}),h(R)!=="svelte-1vzm9q"&&(R.textContent=Ne),he.forEach(t),ye=i(p),D=n(p,"DIV",{class:!0});var fe=d(D);w(N.$$.fragment,fe),we=i(fe),W=n(fe,"P",{"data-svelte-h":!0}),h(W)!=="svelte-hi84tp"&&(W.textContent=He),fe.forEach(t),p.forEach(t),ie=i(e),_=n(e,"H2",{class:!0});var me=d(_);$=n(me,"A",{id:!0,class:!0,href:!0});var Re=d($);X=n(Re,"SPAN",{});var We=d(X);w(H.$$.fragment,We),We.forEach(t),Re.forEach(t),Te=i(me),j=n(me,"SPAN",{"data-svelte-h":!0}),h(j)!=="svelte-3upulb"&&(j.textContent=Ie),me.forEach(t),ae=i(e),v=n(e,"DIV",{class:!0});var ge=d(v);w(I.$$.fragment,ge),Ce=i(ge),B=n(ge,"P",{"data-svelte-h":!0}),h(B)!=="svelte-id9kic"&&(B.innerHTML=Ve),ge.forEach(t),ce=i(e),Z=n(e,"P",{}),d(Z).forEach(t),this.h()},h(){c(f,"name","hf:doc:metadata"),c(f,"content",JSON.stringify(et)),c(b,"id","eulerdiscretescheduler"),c(b,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(b,"href","#eulerdiscretescheduler"),c(m,"class","relative group"),c(E,"id","diffusers.EulerDiscreteScheduler"),c(E,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(E,"href","#diffusers.EulerDiscreteScheduler"),c(g,"class","relative group"),c(S,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(x,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(D,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(l,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c($,"id","diffusers.schedulers.scheduling_euler_discrete.EulerDiscreteSchedulerOutput"),c($,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c($,"href","#diffusers.schedulers.scheduling_euler_discrete.EulerDiscreteSchedulerOutput"),c(_,"class","relative group"),c(v,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,a){r(document.head,f),u(e,te,a),u(e,J,a),u(e,re,a),u(e,m,a),r(m,b),r(b,Y),T(O,Y,null),r(m,_e),r(m,V),u(e,se,a),u(e,F,a),u(e,ne,a),u(e,g,a),r(g,E),r(E,Q),T(L,Q,null),r(g,ve),r(g,U),u(e,oe,a),u(e,l,a),T(A,l,null),r(l,be),r(l,z),r(l,Ee),r(l,G),r(l,Se),r(l,S),T(q,S,null),r(S,xe),r(S,K),r(l,De),r(l,x),T(M,x,null),r(x,$e),r(x,R),r(l,ye),r(l,D),T(N,D,null),r(D,we),r(D,W),u(e,ie,a),u(e,_,a),r(_,$),r($,X),T(H,X,null),r(_,Te),r(_,j),u(e,ae,a),u(e,v,a),T(I,v,null),r(v,Ce),r(v,B),u(e,ce,a),u(e,Z,a),le=!0},p:Be,i(e){le||(C(O.$$.fragment,e),C(L.$$.fragment,e),C(A.$$.fragment,e),C(q.$$.fragment,e),C(M.$$.fragment,e),C(N.$$.fragment,e),C(H.$$.fragment,e),C(I.$$.fragment,e),le=!0)},o(e){k(O.$$.fragment,e),k(L.$$.fragment,e),k(A.$$.fragment,e),k(q.$$.fragment,e),k(M.$$.fragment,e),k(N.$$.fragment,e),k(H.$$.fragment,e),k(I.$$.fragment,e),le=!1},d(e){e&&(t(te),t(J),t(re),t(m),t(se),t(F),t(ne),t(g),t(oe),t(l),t(ie),t(_),t(ae),t(v),t(ce),t(Z)),t(f),P(O),P(L),P(A),P(q),P(M),P(N),P(H),P(I)}}}const et={local:"eulerdiscretescheduler",sections:[{local:"diffusers.EulerDiscreteScheduler",title:"EulerDiscreteScheduler"},{local:"diffusers.schedulers.scheduling_euler_discrete.EulerDiscreteSchedulerOutput",title:"EulerDiscreteSchedulerOutput"}],title:"EulerDiscreteScheduler"};function tt(Pe){return Je(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class it extends Ye{constructor(f){super(),Qe(this,f,tt,Ze,je,{})}}export{it as component};
