import{s as et,n as tt,o as st}from"../chunks/scheduler.182ea377.js";import{S as rt,i as nt,g as r,s as o,u as S,A as ot,h as n,f as t,c as i,j as l,v as b,y as h,k as a,o as s,a as u,w as $,d as x,t as D,x as L}from"../chunks/index.caaccc80.js";import{D as X}from"../chunks/Docstring.835fbd1d.js";import{I as Ae}from"../chunks/IconCopyLink.3458bfff.js";function it(Ne){let f,ne,Z,oe,m,y,ee,E,$e,z,Ie="LMSDiscreteScheduler",ie,F,qe='<code>LMSDiscreteScheduler</code> is a linear multistep scheduler for discrete beta schedules. The scheduler is ported from and created by <a href="https://github.com/crowsonkb/" rel="nofollow">Katherine Crowson</a>, and the original implementation can be found at <a href="https://github.com/crowsonkb/k-diffusion/blob/481677d114f6ea445aa009cf5bd7a9cdee909e47/k_diffusion/sampling.py#L181" rel="nofollow">crowsonkb/k-diffusion</a>.',ae,g,M,te,O,xe,j,He="LMSDiscreteScheduler",de,d,A,De,K,Ve="A linear multistep scheduler for discrete beta schedules.",Le,R,Ue=`This model inherits from <a href="/docs/diffusers/main/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a> and <a href="/docs/diffusers/main/en/api/configuration#diffusers.ConfigMixin">ConfigMixin</a>. Check the superclass documentation for the generic
methods the library implements for all schedulers such as loading and saving.`,ye,w,N,Me,W,ze="Compute the linear multistep coefficient.",we,T,I,Te,J,je=`Ensures interchangeability with schedulers that need to scale the denoising model input depending on the
current timestep.`,Ce,C,q,ke,Y,Ke="Sets the discrete timesteps used for the diffusion chain (to be run before inference).",Pe,k,H,Ee,B,Re=`Predict the sample from the previous timestep by reversing the SDE. This function propagates the diffusion
process from the learned model outputs (most often the predicted noise).`,ce,_,P,se,V,Fe,G,We="LMSDiscreteSchedulerOutput",le,v,U,Oe,Q,Je="Output class for the scheduler’s <code>step</code> function output.",ue,re,pe;return E=new Ae({}),O=new Ae({}),A=new X({props:{name:"class diffusers.LMSDiscreteScheduler",anchor:"diffusers.LMSDiscreteScheduler",parameters:[{name:"num_train_timesteps",val:": int = 1000"},{name:"beta_start",val:": float = 0.0001"},{name:"beta_end",val:": float = 0.02"},{name:"beta_schedule",val:": str = 'linear'"},{name:"trained_betas",val:": typing.Union[numpy.ndarray, typing.List[float], NoneType] = None"},{name:"use_karras_sigmas",val:": typing.Optional[bool] = False"},{name:"prediction_type",val:": str = 'epsilon'"},{name:"timestep_spacing",val:": str = 'linspace'"},{name:"steps_offset",val:": int = 0"}],parametersDescription:[{anchor:"diffusers.LMSDiscreteScheduler.num_train_timesteps",description:`<strong>num_train_timesteps</strong> (<code>int</code>, defaults to 1000) &#x2014;
The number of diffusion steps to train the model.`,name:"num_train_timesteps"},{anchor:"diffusers.LMSDiscreteScheduler.beta_start",description:`<strong>beta_start</strong> (<code>float</code>, defaults to 0.0001) &#x2014;
The starting <code>beta</code> value of inference.`,name:"beta_start"},{anchor:"diffusers.LMSDiscreteScheduler.beta_end",description:`<strong>beta_end</strong> (<code>float</code>, defaults to 0.02) &#x2014;
The final <code>beta</code> value.`,name:"beta_end"},{anchor:"diffusers.LMSDiscreteScheduler.beta_schedule",description:`<strong>beta_schedule</strong> (<code>str</code>, defaults to <code>&quot;linear&quot;</code>) &#x2014;
The beta schedule, a mapping from a beta range to a sequence of betas for stepping the model. Choose from
<code>linear</code> or <code>scaled_linear</code>.`,name:"beta_schedule"},{anchor:"diffusers.LMSDiscreteScheduler.trained_betas",description:`<strong>trained_betas</strong> (<code>np.ndarray</code>, <em>optional</em>) &#x2014;
Pass an array of betas directly to the constructor to bypass <code>beta_start</code> and <code>beta_end</code>.`,name:"trained_betas"},{anchor:"diffusers.LMSDiscreteScheduler.use_karras_sigmas",description:`<strong>use_karras_sigmas</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to use Karras sigmas for step sizes in the noise schedule during the sampling process. If <code>True</code>,
the sigmas are determined according to a sequence of noise levels {&#x3C3;i}.`,name:"use_karras_sigmas"},{anchor:"diffusers.LMSDiscreteScheduler.prediction_type",description:`<strong>prediction_type</strong> (<code>str</code>, defaults to <code>epsilon</code>, <em>optional</em>) &#x2014;
Prediction type of the scheduler function; can be <code>epsilon</code> (predicts the noise of the diffusion process),
<code>sample</code> (directly predicts the noisy sample<code>) or </code>v_prediction\` (see section 2.4 of <a href="https://imagen.research.google/video/paper.pdf" rel="nofollow">Imagen
Video</a> paper).`,name:"prediction_type"},{anchor:"diffusers.LMSDiscreteScheduler.timestep_spacing",description:`<strong>timestep_spacing</strong> (<code>str</code>, defaults to <code>&quot;linspace&quot;</code>) &#x2014;
The way the timesteps should be scaled. Refer to Table 2 of the <a href="https://huggingface.co/papers/2305.08891" rel="nofollow">Common Diffusion Noise Schedules and
Sample Steps are Flawed</a> for more information.`,name:"timestep_spacing"},{anchor:"diffusers.LMSDiscreteScheduler.steps_offset",description:`<strong>steps_offset</strong> (<code>int</code>, defaults to 0) &#x2014;
An offset added to the inference steps. You can use a combination of <code>offset=1</code> and
<code>set_alpha_to_one=False</code> to make the last step use step 0 for the previous alpha product like in Stable
Diffusion.`,name:"steps_offset"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_lms_discrete.py#L92"}}),N=new X({props:{name:"get_lms_coefficient",anchor:"diffusers.LMSDiscreteScheduler.get_lms_coefficient",parameters:[{name:"order",val:""},{name:"t",val:""},{name:"current_order",val:""}],parametersDescription:[{anchor:"diffusers.LMSDiscreteScheduler.get_lms_coefficient.order",description:"<strong>order</strong> () &#x2014;",name:"order"},{anchor:"diffusers.LMSDiscreteScheduler.get_lms_coefficient.t",description:"<strong>t</strong> () &#x2014;",name:"t"},{anchor:"diffusers.LMSDiscreteScheduler.get_lms_coefficient.current_order",description:"<strong>current_order</strong> () &#x2014;",name:"current_order"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_lms_discrete.py#L215"}}),I=new X({props:{name:"scale_model_input",anchor:"diffusers.LMSDiscreteScheduler.scale_model_input",parameters:[{name:"sample",val:": FloatTensor"},{name:"timestep",val:": typing.Union[float, torch.FloatTensor]"}],parametersDescription:[{anchor:"diffusers.LMSDiscreteScheduler.scale_model_input.sample",description:`<strong>sample</strong> (<code>torch.FloatTensor</code>) &#x2014;
The input sample.`,name:"sample"},{anchor:"diffusers.LMSDiscreteScheduler.scale_model_input.timestep",description:`<strong>timestep</strong> (<code>float</code> or <code>torch.FloatTensor</code>) &#x2014;
The current timestep in the diffusion chain.`,name:"timestep"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_lms_discrete.py#L189",returnDescription:`
<p>A scaled input sample.</p>
`,returnType:`
<p><code>torch.FloatTensor</code></p>
`}}),q=new X({props:{name:"set_timesteps",anchor:"diffusers.LMSDiscreteScheduler.set_timesteps",parameters:[{name:"num_inference_steps",val:": int"},{name:"device",val:": typing.Union[str, torch.device] = None"}],parametersDescription:[{anchor:"diffusers.LMSDiscreteScheduler.set_timesteps.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>) &#x2014;
The number of diffusion steps used when generating samples with a pre-trained model.`,name:"num_inference_steps"},{anchor:"diffusers.LMSDiscreteScheduler.set_timesteps.device",description:`<strong>device</strong> (<code>str</code> or <code>torch.device</code>, <em>optional</em>) &#x2014;
The device to which the timesteps should be moved to. If <code>None</code>, the timesteps are not moved.`,name:"device"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_lms_discrete.py#L237"}}),H=new X({props:{name:"step",anchor:"diffusers.LMSDiscreteScheduler.step",parameters:[{name:"model_output",val:": FloatTensor"},{name:"timestep",val:": typing.Union[float, torch.FloatTensor]"},{name:"sample",val:": FloatTensor"},{name:"order",val:": int = 4"},{name:"return_dict",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.LMSDiscreteScheduler.step.model_output",description:`<strong>model_output</strong> (<code>torch.FloatTensor</code>) &#x2014;
The direct output from learned diffusion model.`,name:"model_output"},{anchor:"diffusers.LMSDiscreteScheduler.step.timestep",description:`<strong>timestep</strong> (<code>float</code> or <code>torch.FloatTensor</code>) &#x2014;
The current discrete timestep in the diffusion chain.`,name:"timestep"},{anchor:"diffusers.LMSDiscreteScheduler.step.sample",description:`<strong>sample</strong> (<code>torch.FloatTensor</code>) &#x2014;
A current instance of a sample created by the diffusion process.`,name:"sample"},{anchor:"diffusers.LMSDiscreteScheduler.step.order",description:`<strong>order</strong> (<code>int</code>, defaults to 4) &#x2014;
The order of the linear multistep method.`,name:"order"},{anchor:"diffusers.LMSDiscreteScheduler.step.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/main/en/api/schedulers/singlestep_dpm_solver#diffusers.schedulers.scheduling_utils.SchedulerOutput">SchedulerOutput</a> or tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_lms_discrete.py#L343",returnDescription:`
<p>If return_dict is <code>True</code>, <a
  href="/docs/diffusers/main/en/api/schedulers/singlestep_dpm_solver#diffusers.schedulers.scheduling_utils.SchedulerOutput"
>SchedulerOutput</a> is returned, otherwise a
tuple is returned where the first element is the sample tensor.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/main/en/api/schedulers/singlestep_dpm_solver#diffusers.schedulers.scheduling_utils.SchedulerOutput"
>SchedulerOutput</a> or <code>tuple</code></p>
`}}),V=new Ae({}),U=new X({props:{name:"class diffusers.schedulers.scheduling_lms_discrete.LMSDiscreteSchedulerOutput",anchor:"diffusers.schedulers.scheduling_lms_discrete.LMSDiscreteSchedulerOutput",parameters:[{name:"prev_sample",val:": FloatTensor"},{name:"pred_original_sample",val:": typing.Optional[torch.FloatTensor] = None"}],parametersDescription:[{anchor:"diffusers.schedulers.scheduling_lms_discrete.LMSDiscreteSchedulerOutput.prev_sample",description:`<strong>prev_sample</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code> for images) &#x2014;
Computed sample <code>(x_{t-1})</code> of previous timestep. <code>prev_sample</code> should be used as next model input in the
denoising loop.`,name:"prev_sample"},{anchor:"diffusers.schedulers.scheduling_lms_discrete.LMSDiscreteSchedulerOutput.pred_original_sample",description:`<strong>pred_original_sample</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code> for images) &#x2014;
The predicted denoised sample <code>(x_{0})</code> based on the model output from the current timestep.
<code>pred_original_sample</code> can be used to preview progress or for guidance.`,name:"pred_original_sample"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_lms_discrete.py#L30"}}),{c(){f=r("meta"),ne=o(),Z=r("p"),oe=o(),m=r("h1"),y=r("a"),ee=r("span"),S(E.$$.fragment),$e=o(),z=r("span"),z.textContent=Ie,ie=o(),F=r("p"),F.innerHTML=qe,ae=o(),g=r("h2"),M=r("a"),te=r("span"),S(O.$$.fragment),xe=o(),j=r("span"),j.textContent=He,de=o(),d=r("div"),S(A.$$.fragment),De=o(),K=r("p"),K.textContent=Ve,Le=o(),R=r("p"),R.innerHTML=Ue,ye=o(),w=r("div"),S(N.$$.fragment),Me=o(),W=r("p"),W.textContent=ze,we=o(),T=r("div"),S(I.$$.fragment),Te=o(),J=r("p"),J.textContent=je,Ce=o(),C=r("div"),S(q.$$.fragment),ke=o(),Y=r("p"),Y.textContent=Ke,Pe=o(),k=r("div"),S(H.$$.fragment),Ee=o(),B=r("p"),B.textContent=Re,ce=o(),_=r("h2"),P=r("a"),se=r("span"),S(V.$$.fragment),Fe=o(),G=r("span"),G.textContent=We,le=o(),v=r("div"),S(U.$$.fragment),Oe=o(),Q=r("p"),Q.innerHTML=Je,ue=o(),re=r("p"),this.h()},l(e){const c=ot("svelte-1phssyn",document.head);f=n(c,"META",{name:!0,content:!0}),c.forEach(t),ne=i(e),Z=n(e,"P",{}),l(Z).forEach(t),oe=i(e),m=n(e,"H1",{class:!0});var he=l(m);y=n(he,"A",{id:!0,class:!0,href:!0});var Ye=l(y);ee=n(Ye,"SPAN",{});var Be=l(ee);b(E.$$.fragment,Be),Be.forEach(t),Ye.forEach(t),$e=i(he),z=n(he,"SPAN",{"data-svelte-h":!0}),h(z)!=="svelte-1ckq97d"&&(z.textContent=Ie),he.forEach(t),ie=i(e),F=n(e,"P",{"data-svelte-h":!0}),h(F)!=="svelte-1otp9cb"&&(F.innerHTML=qe),ae=i(e),g=n(e,"H2",{class:!0});var fe=l(g);M=n(fe,"A",{id:!0,class:!0,href:!0});var Ge=l(M);te=n(Ge,"SPAN",{});var Qe=l(te);b(O.$$.fragment,Qe),Qe.forEach(t),Ge.forEach(t),xe=i(fe),j=n(fe,"SPAN",{"data-svelte-h":!0}),h(j)!=="svelte-1ckq97d"&&(j.textContent=He),fe.forEach(t),de=i(e),d=n(e,"DIV",{class:!0});var p=l(d);b(A.$$.fragment,p),De=i(p),K=n(p,"P",{"data-svelte-h":!0}),h(K)!=="svelte-1s0vl92"&&(K.textContent=Ve),Le=i(p),R=n(p,"P",{"data-svelte-h":!0}),h(R)!=="svelte-linuuh"&&(R.innerHTML=Ue),ye=i(p),w=n(p,"DIV",{class:!0});var me=l(w);b(N.$$.fragment,me),Me=i(me),W=n(me,"P",{"data-svelte-h":!0}),h(W)!=="svelte-l6j38t"&&(W.textContent=ze),me.forEach(t),we=i(p),T=n(p,"DIV",{class:!0});var ge=l(T);b(I.$$.fragment,ge),Te=i(ge),J=n(ge,"P",{"data-svelte-h":!0}),h(J)!=="svelte-1rkfgpx"&&(J.textContent=je),ge.forEach(t),Ce=i(p),C=n(p,"DIV",{class:!0});var _e=l(C);b(q.$$.fragment,_e),ke=i(_e),Y=n(_e,"P",{"data-svelte-h":!0}),h(Y)!=="svelte-1vzm9q"&&(Y.textContent=Ke),_e.forEach(t),Pe=i(p),k=n(p,"DIV",{class:!0});var ve=l(k);b(H.$$.fragment,ve),Ee=i(ve),B=n(ve,"P",{"data-svelte-h":!0}),h(B)!=="svelte-hi84tp"&&(B.textContent=Re),ve.forEach(t),p.forEach(t),ce=i(e),_=n(e,"H2",{class:!0});var Se=l(_);P=n(Se,"A",{id:!0,class:!0,href:!0});var Xe=l(P);se=n(Xe,"SPAN",{});var Ze=l(se);b(V.$$.fragment,Ze),Ze.forEach(t),Xe.forEach(t),Fe=i(Se),G=n(Se,"SPAN",{"data-svelte-h":!0}),h(G)!=="svelte-1nx3ogi"&&(G.textContent=We),Se.forEach(t),le=i(e),v=n(e,"DIV",{class:!0});var be=l(v);b(U.$$.fragment,be),Oe=i(be),Q=n(be,"P",{"data-svelte-h":!0}),h(Q)!=="svelte-id9kic"&&(Q.innerHTML=Je),be.forEach(t),ue=i(e),re=n(e,"P",{}),l(re).forEach(t),this.h()},h(){a(f,"name","hf:doc:metadata"),a(f,"content",JSON.stringify(at)),a(y,"id","lmsdiscretescheduler"),a(y,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(y,"href","#lmsdiscretescheduler"),a(m,"class","relative group"),a(M,"id","diffusers.LMSDiscreteScheduler"),a(M,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(M,"href","#diffusers.LMSDiscreteScheduler"),a(g,"class","relative group"),a(w,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(T,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(C,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(k,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(d,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(P,"id","diffusers.schedulers.scheduling_lms_discrete.LMSDiscreteSchedulerOutput"),a(P,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(P,"href","#diffusers.schedulers.scheduling_lms_discrete.LMSDiscreteSchedulerOutput"),a(_,"class","relative group"),a(v,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,c){s(document.head,f),u(e,ne,c),u(e,Z,c),u(e,oe,c),u(e,m,c),s(m,y),s(y,ee),$(E,ee,null),s(m,$e),s(m,z),u(e,ie,c),u(e,F,c),u(e,ae,c),u(e,g,c),s(g,M),s(M,te),$(O,te,null),s(g,xe),s(g,j),u(e,de,c),u(e,d,c),$(A,d,null),s(d,De),s(d,K),s(d,Le),s(d,R),s(d,ye),s(d,w),$(N,w,null),s(w,Me),s(w,W),s(d,we),s(d,T),$(I,T,null),s(T,Te),s(T,J),s(d,Ce),s(d,C),$(q,C,null),s(C,ke),s(C,Y),s(d,Pe),s(d,k),$(H,k,null),s(k,Ee),s(k,B),u(e,ce,c),u(e,_,c),s(_,P),s(P,se),$(V,se,null),s(_,Fe),s(_,G),u(e,le,c),u(e,v,c),$(U,v,null),s(v,Oe),s(v,Q),u(e,ue,c),u(e,re,c),pe=!0},p:tt,i(e){pe||(x(E.$$.fragment,e),x(O.$$.fragment,e),x(A.$$.fragment,e),x(N.$$.fragment,e),x(I.$$.fragment,e),x(q.$$.fragment,e),x(H.$$.fragment,e),x(V.$$.fragment,e),x(U.$$.fragment,e),pe=!0)},o(e){D(E.$$.fragment,e),D(O.$$.fragment,e),D(A.$$.fragment,e),D(N.$$.fragment,e),D(I.$$.fragment,e),D(q.$$.fragment,e),D(H.$$.fragment,e),D(V.$$.fragment,e),D(U.$$.fragment,e),pe=!1},d(e){e&&(t(ne),t(Z),t(oe),t(m),t(ie),t(F),t(ae),t(g),t(de),t(d),t(ce),t(_),t(le),t(v),t(ue),t(re)),t(f),L(E),L(O),L(A),L(N),L(I),L(q),L(H),L(V),L(U)}}}const at={local:"lmsdiscretescheduler",sections:[{local:"diffusers.LMSDiscreteScheduler",title:"LMSDiscreteScheduler"},{local:"diffusers.schedulers.scheduling_lms_discrete.LMSDiscreteSchedulerOutput",title:"LMSDiscreteSchedulerOutput"}],title:"LMSDiscreteScheduler"};function dt(Ne){return st(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ht extends rt{constructor(f){super(),nt(this,f,dt,it,et,{})}}export{ht as component};
