import{s as Vt,o as jt,n as zt}from"../chunks/scheduler.182ea377.js";import{S as Gt,i as Wt,g as s,s as n,u as f,A as Jt,h as o,f as r,c as l,j as c,v,y as h,k as a,o as t,a as p,w as g,d as _,t as S,x as b}from"../chunks/index.caaccc80.js";import{T as Rt}from"../chunks/Tip.e9d11def.js";import{D as I}from"../chunks/Docstring.835fbd1d.js";import{I as Re}from"../chunks/IconCopyLink.3458bfff.js";function Ut(ye){let m,V=`The algorithm and model type are decoupled. You can use either DPMSolver or DPMSolver++ for both noise
prediction and data prediction models.`;return{c(){m=s("p"),m.textContent=V},l(M){m=o(M,"P",{"data-svelte-h":!0}),h(m)!=="svelte-95n5s"&&(m.textContent=V)},m(M,oe){p(M,m,oe)},p:zt,d(M){M&&r(m)}}}function Yt(ye){let m,V,M,oe,x,w,be,j,Ue,ne,ft="DPMSolverMultistepInverse",Pe,z,vt='<code>DPMSolverMultistepInverse</code> is the inverted scheduler from <a href="https://huggingface.co/papers/2206.00927" rel="nofollow">DPM-Solver: A Fast ODE Solver for Diffusion Probabilistic Model Sampling in Around 10 Steps</a> and <a href="https://huggingface.co/papers/2211.01095" rel="nofollow">DPM-Solver++: Fast Solver for Guided Sampling of Diffusion Probabilistic Models</a> by Cheng Lu, Yuhao Zhou, Fan Bao, Jianfei Chen, Chongxuan Li, and Jun Zhu.',Te,G,gt='The implementation is mostly based on the DDIM inversion definition of <a href="https://huggingface.co/papers/2211.09794.pdf" rel="nofollow">Null-text Inversion for Editing Real Images using Guided Diffusion Models</a> and notebook implementation of the <code>DiffEdit</code> latent inversion from <a href="https://github.com/Xiang-cd/DiffEdit-stable-diffusion/blob/main/diffedit.ipynb" rel="nofollow">Xiang-cd/DiffEdit-stable-diffusion</a>.',Ie,D,C,Me,W,Ye,le,_t="Tips",we,J,St=`Dynamic thresholding from Imagen (<a href="https://huggingface.co/papers/2205.11487" rel="nofollow">https://huggingface.co/papers/2205.11487</a>) is supported, and for pixel-space
diffusion models, you can set both <code>algorithm_type=&quot;dpmsolver++&quot;</code> and <code>thresholding=True</code> to use the dynamic
thresholding. This thresholding method is unsuitable for latent-space diffusion models such as
Stable Diffusion.`,Ce,y,F,$e,R,Be,ie,bt="DPMSolverMultistepInverseScheduler",Fe,d,U,Xe,ae,Mt='<code>DPMSolverMultistepInverseScheduler</code> is the reverse scheduler of <a href="/docs/diffusers/main/en/api/schedulers/multistep_dpm_solver#diffusers.DPMSolverMultistepScheduler">DPMSolverMultistepScheduler</a>.',Ze,de,$t=`This model inherits from <a href="/docs/diffusers/main/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a> and <a href="/docs/diffusers/main/en/api/configuration#diffusers.ConfigMixin">ConfigMixin</a>. Check the superclass documentation for the generic
methods the library implements for all schedulers such as loading and saving.`,Ke,$,Y,Qe,ce,xt=`Convert the model output to the corresponding type the DPMSolver/DPMSolver++ algorithm needs. DPM-Solver is
designed to discretize an integral of the noise prediction model, and DPM-Solver++ is designed to discretize an
integral of the data prediction model.`,et,E,tt,k,B,rt,pe,Dt="One step for the first-order DPMSolver (equivalent to DDIM).",st,L,X,ot,ue,yt="One step for the second-order multistep DPMSolver.",nt,A,Z,lt,he,Pt="One step for the third-order multistep DPMSolver.",it,N,K,at,me,Tt=`Ensures interchangeability with schedulers that need to scale the denoising model input depending on the
current timestep.`,dt,O,Q,ct,fe,It="Sets the discrete timesteps used for the diffusion chain (to be run before inference).",pt,q,ee,ut,ve,wt=`Predict the sample from the previous timestep by reversing the SDE. This function propagates the sample with
the multistep DPMSolver.`,Ee,P,H,xe,te,ht,ge,Ct="SchedulerOutput",ke,T,re,mt,_e,Ft="Base class for the output of a scheduler’s <code>step</code> function.",Le,De,Ae;return j=new Re({}),W=new Re({}),R=new Re({}),U=new I({props:{name:"class diffusers.DPMSolverMultistepInverseScheduler",anchor:"diffusers.DPMSolverMultistepInverseScheduler",parameters:[{name:"num_train_timesteps",val:": int = 1000"},{name:"beta_start",val:": float = 0.0001"},{name:"beta_end",val:": float = 0.02"},{name:"beta_schedule",val:": str = 'linear'"},{name:"trained_betas",val:": typing.Union[numpy.ndarray, typing.List[float], NoneType] = None"},{name:"solver_order",val:": int = 2"},{name:"prediction_type",val:": str = 'epsilon'"},{name:"thresholding",val:": bool = False"},{name:"dynamic_thresholding_ratio",val:": float = 0.995"},{name:"sample_max_value",val:": float = 1.0"},{name:"algorithm_type",val:": str = 'dpmsolver++'"},{name:"solver_type",val:": str = 'midpoint'"},{name:"lower_order_final",val:": bool = True"},{name:"use_karras_sigmas",val:": typing.Optional[bool] = False"},{name:"lambda_min_clipped",val:": float = -inf"},{name:"variance_type",val:": typing.Optional[str] = None"},{name:"timestep_spacing",val:": str = 'linspace'"},{name:"steps_offset",val:": int = 0"}],parametersDescription:[{anchor:"diffusers.DPMSolverMultistepInverseScheduler.num_train_timesteps",description:`<strong>num_train_timesteps</strong> (<code>int</code>, defaults to 1000) &#x2014;
The number of diffusion steps to train the model.`,name:"num_train_timesteps"},{anchor:"diffusers.DPMSolverMultistepInverseScheduler.beta_start",description:`<strong>beta_start</strong> (<code>float</code>, defaults to 0.0001) &#x2014;
The starting <code>beta</code> value of inference.`,name:"beta_start"},{anchor:"diffusers.DPMSolverMultistepInverseScheduler.beta_end",description:`<strong>beta_end</strong> (<code>float</code>, defaults to 0.02) &#x2014;
The final <code>beta</code> value.`,name:"beta_end"},{anchor:"diffusers.DPMSolverMultistepInverseScheduler.beta_schedule",description:`<strong>beta_schedule</strong> (<code>str</code>, defaults to <code>&quot;linear&quot;</code>) &#x2014;
The beta schedule, a mapping from a beta range to a sequence of betas for stepping the model. Choose from
<code>linear</code>, <code>scaled_linear</code>, or <code>squaredcos_cap_v2</code>.`,name:"beta_schedule"},{anchor:"diffusers.DPMSolverMultistepInverseScheduler.trained_betas",description:`<strong>trained_betas</strong> (<code>np.ndarray</code>, <em>optional</em>) &#x2014;
Pass an array of betas directly to the constructor to bypass <code>beta_start</code> and <code>beta_end</code>.`,name:"trained_betas"},{anchor:"diffusers.DPMSolverMultistepInverseScheduler.solver_order",description:`<strong>solver_order</strong> (<code>int</code>, defaults to 2) &#x2014;
The DPMSolver order which can be <code>1</code> or <code>2</code> or <code>3</code>. It is recommended to use <code>solver_order=2</code> for guided
sampling, and <code>solver_order=3</code> for unconditional sampling.`,name:"solver_order"},{anchor:"diffusers.DPMSolverMultistepInverseScheduler.prediction_type",description:`<strong>prediction_type</strong> (<code>str</code>, defaults to <code>epsilon</code>, <em>optional</em>) &#x2014;
Prediction type of the scheduler function; can be <code>epsilon</code> (predicts the noise of the diffusion process),
<code>sample</code> (directly predicts the noisy sample<code>) or </code>v_prediction\` (see section 2.4 of <a href="https://imagen.research.google/video/paper.pdf" rel="nofollow">Imagen
Video</a> paper).`,name:"prediction_type"},{anchor:"diffusers.DPMSolverMultistepInverseScheduler.thresholding",description:`<strong>thresholding</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to use the &#x201C;dynamic thresholding&#x201D; method. This is unsuitable for latent-space diffusion models such
as Stable Diffusion.`,name:"thresholding"},{anchor:"diffusers.DPMSolverMultistepInverseScheduler.dynamic_thresholding_ratio",description:`<strong>dynamic_thresholding_ratio</strong> (<code>float</code>, defaults to 0.995) &#x2014;
The ratio for the dynamic thresholding method. Valid only when <code>thresholding=True</code>.`,name:"dynamic_thresholding_ratio"},{anchor:"diffusers.DPMSolverMultistepInverseScheduler.sample_max_value",description:`<strong>sample_max_value</strong> (<code>float</code>, defaults to 1.0) &#x2014;
The threshold value for dynamic thresholding. Valid only when <code>thresholding=True</code> and
<code>algorithm_type=&quot;dpmsolver++&quot;</code>.`,name:"sample_max_value"},{anchor:"diffusers.DPMSolverMultistepInverseScheduler.algorithm_type",description:`<strong>algorithm_type</strong> (<code>str</code>, defaults to <code>dpmsolver++</code>) &#x2014;
Algorithm type for the solver; can be <code>dpmsolver</code>, <code>dpmsolver++</code>, <code>sde-dpmsolver</code> or <code>sde-dpmsolver++</code>. The
<code>dpmsolver</code> type implements the algorithms in the <a href="https://huggingface.co/papers/2206.00927" rel="nofollow">DPMSolver</a>
paper, and the <code>dpmsolver++</code> type implements the algorithms in the
<a href="https://huggingface.co/papers/2211.01095" rel="nofollow">DPMSolver++</a> paper. It is recommended to use <code>dpmsolver++</code> or
<code>sde-dpmsolver++</code> with <code>solver_order=2</code> for guided sampling like in Stable Diffusion.`,name:"algorithm_type"},{anchor:"diffusers.DPMSolverMultistepInverseScheduler.solver_type",description:`<strong>solver_type</strong> (<code>str</code>, defaults to <code>midpoint</code>) &#x2014;
Solver type for the second-order solver; can be <code>midpoint</code> or <code>heun</code>. The solver type slightly affects the
sample quality, especially for a small number of steps. It is recommended to use <code>midpoint</code> solvers.`,name:"solver_type"},{anchor:"diffusers.DPMSolverMultistepInverseScheduler.lower_order_final",description:`<strong>lower_order_final</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether to use lower-order solvers in the final steps. Only valid for &lt; 15 inference steps. This can
stabilize the sampling of DPMSolver for steps &lt; 15, especially for steps &lt;= 10.`,name:"lower_order_final"},{anchor:"diffusers.DPMSolverMultistepInverseScheduler.use_karras_sigmas",description:`<strong>use_karras_sigmas</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to use Karras sigmas for step sizes in the noise schedule during the sampling process. If <code>True</code>,
the sigmas are determined according to a sequence of noise levels {&#x3C3;i}.`,name:"use_karras_sigmas"},{anchor:"diffusers.DPMSolverMultistepInverseScheduler.lambda_min_clipped",description:`<strong>lambda_min_clipped</strong> (<code>float</code>, defaults to <code>-inf</code>) &#x2014;
Clipping threshold for the minimum value of <code>lambda(t)</code> for numerical stability. This is critical for the
cosine (<code>squaredcos_cap_v2</code>) noise schedule.`,name:"lambda_min_clipped"},{anchor:"diffusers.DPMSolverMultistepInverseScheduler.variance_type",description:`<strong>variance_type</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Set to &#x201C;learned&#x201D; or &#x201C;learned_range&#x201D; for diffusion models that predict variance. If set, the model&#x2019;s output
contains the predicted Gaussian variance.`,name:"variance_type"},{anchor:"diffusers.DPMSolverMultistepInverseScheduler.timestep_spacing",description:`<strong>timestep_spacing</strong> (<code>str</code>, defaults to <code>&quot;linspace&quot;</code>) &#x2014;
The way the timesteps should be scaled. Refer to Table 2 of the <a href="https://huggingface.co/papers/2305.08891" rel="nofollow">Common Diffusion Noise Schedules and
Sample Steps are Flawed</a> for more information.`,name:"timestep_spacing"},{anchor:"diffusers.DPMSolverMultistepInverseScheduler.steps_offset",description:`<strong>steps_offset</strong> (<code>int</code>, defaults to 0) &#x2014;
An offset added to the inference steps. You can use a combination of <code>offset=1</code> and
<code>set_alpha_to_one=False</code> to make the last step use step 0 for the previous alpha product like in Stable
Diffusion.`,name:"steps_offset"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_dpmsolver_multistep_inverse.py#L74"}}),Y=new I({props:{name:"convert_model_output",anchor:"diffusers.DPMSolverMultistepInverseScheduler.convert_model_output",parameters:[{name:"model_output",val:": FloatTensor"},{name:"*args",val:""},{name:"sample",val:": FloatTensor = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"diffusers.DPMSolverMultistepInverseScheduler.convert_model_output.model_output",description:`<strong>model_output</strong> (<code>torch.FloatTensor</code>) &#x2014;
The direct output from the learned diffusion model.`,name:"model_output"},{anchor:"diffusers.DPMSolverMultistepInverseScheduler.convert_model_output.sample",description:`<strong>sample</strong> (<code>torch.FloatTensor</code>) &#x2014;
A current instance of a sample created by the diffusion process.`,name:"sample"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_dpmsolver_multistep_inverse.py#L370",returnDescription:`
<p>The converted model output.</p>
`,returnType:`
<p><code>torch.FloatTensor</code></p>
`}}),E=new Rt({props:{$$slots:{default:[Ut]},$$scope:{ctx:ye}}}),B=new I({props:{name:"dpm_solver_first_order_update",anchor:"diffusers.DPMSolverMultistepInverseScheduler.dpm_solver_first_order_update",parameters:[{name:"model_output",val:": FloatTensor"},{name:"*args",val:""},{name:"sample",val:": FloatTensor = None"},{name:"noise",val:": typing.Optional[torch.FloatTensor] = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"diffusers.DPMSolverMultistepInverseScheduler.dpm_solver_first_order_update.model_output",description:`<strong>model_output</strong> (<code>torch.FloatTensor</code>) &#x2014;
The direct output from the learned diffusion model.`,name:"model_output"},{anchor:"diffusers.DPMSolverMultistepInverseScheduler.dpm_solver_first_order_update.sample",description:`<strong>sample</strong> (<code>torch.FloatTensor</code>) &#x2014;
A current instance of a sample created by the diffusion process.`,name:"sample"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_dpmsolver_multistep_inverse.py#L470",returnDescription:`
<p>The sample tensor at the previous timestep.</p>
`,returnType:`
<p><code>torch.FloatTensor</code></p>
`}}),X=new I({props:{name:"multistep_dpm_solver_second_order_update",anchor:"diffusers.DPMSolverMultistepInverseScheduler.multistep_dpm_solver_second_order_update",parameters:[{name:"model_output_list",val:": typing.List[torch.FloatTensor]"},{name:"*args",val:""},{name:"sample",val:": FloatTensor = None"},{name:"noise",val:": typing.Optional[torch.FloatTensor] = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"diffusers.DPMSolverMultistepInverseScheduler.multistep_dpm_solver_second_order_update.model_output_list",description:`<strong>model_output_list</strong> (<code>List[torch.FloatTensor]</code>) &#x2014;
The direct outputs from learned diffusion model at current and latter timesteps.`,name:"model_output_list"},{anchor:"diffusers.DPMSolverMultistepInverseScheduler.multistep_dpm_solver_second_order_update.sample",description:`<strong>sample</strong> (<code>torch.FloatTensor</code>) &#x2014;
A current instance of a sample created by the diffusion process.`,name:"sample"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_dpmsolver_multistep_inverse.py#L540",returnDescription:`
<p>The sample tensor at the previous timestep.</p>
`,returnType:`
<p><code>torch.FloatTensor</code></p>
`}}),Z=new I({props:{name:"multistep_dpm_solver_third_order_update",anchor:"diffusers.DPMSolverMultistepInverseScheduler.multistep_dpm_solver_third_order_update",parameters:[{name:"model_output_list",val:": typing.List[torch.FloatTensor]"},{name:"*args",val:""},{name:"sample",val:": FloatTensor = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"diffusers.DPMSolverMultistepInverseScheduler.multistep_dpm_solver_third_order_update.model_output_list",description:`<strong>model_output_list</strong> (<code>List[torch.FloatTensor]</code>) &#x2014;
The direct outputs from learned diffusion model at current and latter timesteps.`,name:"model_output_list"},{anchor:"diffusers.DPMSolverMultistepInverseScheduler.multistep_dpm_solver_third_order_update.sample",description:`<strong>sample</strong> (<code>torch.FloatTensor</code>) &#x2014;
A current instance of a sample created by diffusion process.`,name:"sample"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_dpmsolver_multistep_inverse.py#L664",returnDescription:`
<p>The sample tensor at the previous timestep.</p>
`,returnType:`
<p><code>torch.FloatTensor</code></p>
`}}),K=new I({props:{name:"scale_model_input",anchor:"diffusers.DPMSolverMultistepInverseScheduler.scale_model_input",parameters:[{name:"sample",val:": FloatTensor"},{name:"*args",val:""},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"diffusers.DPMSolverMultistepInverseScheduler.scale_model_input.sample",description:`<strong>sample</strong> (<code>torch.FloatTensor</code>) &#x2014;
The input sample.`,name:"sample"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_dpmsolver_multistep_inverse.py#L846",returnDescription:`
<p>A scaled input sample.</p>
`,returnType:`
<p><code>torch.FloatTensor</code></p>
`}}),Q=new I({props:{name:"set_timesteps",anchor:"diffusers.DPMSolverMultistepInverseScheduler.set_timesteps",parameters:[{name:"num_inference_steps",val:": int = None"},{name:"device",val:": typing.Union[str, torch.device] = None"}],parametersDescription:[{anchor:"diffusers.DPMSolverMultistepInverseScheduler.set_timesteps.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>) &#x2014;
The number of diffusion steps used when generating samples with a pre-trained model.`,name:"num_inference_steps"},{anchor:"diffusers.DPMSolverMultistepInverseScheduler.set_timesteps.device",description:`<strong>device</strong> (<code>str</code> or <code>torch.device</code>, <em>optional</em>) &#x2014;
The device to which the timesteps should be moved to. If <code>None</code>, the timesteps are not moved.`,name:"device"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_dpmsolver_multistep_inverse.py#L217"}}),ee=new I({props:{name:"step",anchor:"diffusers.DPMSolverMultistepInverseScheduler.step",parameters:[{name:"model_output",val:": FloatTensor"},{name:"timestep",val:": int"},{name:"sample",val:": FloatTensor"},{name:"generator",val:" = None"},{name:"return_dict",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.DPMSolverMultistepInverseScheduler.step.model_output",description:`<strong>model_output</strong> (<code>torch.FloatTensor</code>) &#x2014;
The direct output from learned diffusion model.`,name:"model_output"},{anchor:"diffusers.DPMSolverMultistepInverseScheduler.step.timestep",description:`<strong>timestep</strong> (<code>int</code>) &#x2014;
The current discrete timestep in the diffusion chain.`,name:"timestep"},{anchor:"diffusers.DPMSolverMultistepInverseScheduler.step.sample",description:`<strong>sample</strong> (<code>torch.FloatTensor</code>) &#x2014;
A current instance of a sample created by the diffusion process.`,name:"sample"},{anchor:"diffusers.DPMSolverMultistepInverseScheduler.step.generator",description:`<strong>generator</strong> (<code>torch.Generator</code>, <em>optional</em>) &#x2014;
A random number generator.`,name:"generator"},{anchor:"diffusers.DPMSolverMultistepInverseScheduler.step.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/main/en/api/schedulers/singlestep_dpm_solver#diffusers.schedulers.scheduling_utils.SchedulerOutput">SchedulerOutput</a> or <code>tuple</code>.`,name:"return_dict"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_dpmsolver_multistep_inverse.py#L770",returnDescription:`
<p>If return_dict is <code>True</code>, <a
  href="/docs/diffusers/main/en/api/schedulers/singlestep_dpm_solver#diffusers.schedulers.scheduling_utils.SchedulerOutput"
>SchedulerOutput</a> is returned, otherwise a
tuple is returned where the first element is the sample tensor.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/main/en/api/schedulers/singlestep_dpm_solver#diffusers.schedulers.scheduling_utils.SchedulerOutput"
>SchedulerOutput</a> or <code>tuple</code></p>
`}}),te=new Re({}),re=new I({props:{name:"class diffusers.schedulers.scheduling_utils.SchedulerOutput",anchor:"diffusers.schedulers.scheduling_utils.SchedulerOutput",parameters:[{name:"prev_sample",val:": FloatTensor"}],parametersDescription:[{anchor:"diffusers.schedulers.scheduling_utils.SchedulerOutput.prev_sample",description:`<strong>prev_sample</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code> for images) &#x2014;
Computed sample <code>(x_{t-1})</code> of previous timestep. <code>prev_sample</code> should be used as next model input in the
denoising loop.`,name:"prev_sample"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_utils.py#L50"}}),{c(){m=s("meta"),V=n(),M=s("p"),oe=n(),x=s("h1"),w=s("a"),be=s("span"),f(j.$$.fragment),Ue=n(),ne=s("span"),ne.textContent=ft,Pe=n(),z=s("p"),z.innerHTML=vt,Te=n(),G=s("p"),G.innerHTML=gt,Ie=n(),D=s("h2"),C=s("a"),Me=s("span"),f(W.$$.fragment),Ye=n(),le=s("span"),le.textContent=_t,we=n(),J=s("p"),J.innerHTML=St,Ce=n(),y=s("h2"),F=s("a"),$e=s("span"),f(R.$$.fragment),Be=n(),ie=s("span"),ie.textContent=bt,Fe=n(),d=s("div"),f(U.$$.fragment),Xe=n(),ae=s("p"),ae.innerHTML=Mt,Ze=n(),de=s("p"),de.innerHTML=$t,Ke=n(),$=s("div"),f(Y.$$.fragment),Qe=n(),ce=s("p"),ce.textContent=xt,et=n(),f(E.$$.fragment),tt=n(),k=s("div"),f(B.$$.fragment),rt=n(),pe=s("p"),pe.textContent=Dt,st=n(),L=s("div"),f(X.$$.fragment),ot=n(),ue=s("p"),ue.textContent=yt,nt=n(),A=s("div"),f(Z.$$.fragment),lt=n(),he=s("p"),he.textContent=Pt,it=n(),N=s("div"),f(K.$$.fragment),at=n(),me=s("p"),me.textContent=Tt,dt=n(),O=s("div"),f(Q.$$.fragment),ct=n(),fe=s("p"),fe.textContent=It,pt=n(),q=s("div"),f(ee.$$.fragment),ut=n(),ve=s("p"),ve.textContent=wt,Ee=n(),P=s("h2"),H=s("a"),xe=s("span"),f(te.$$.fragment),ht=n(),ge=s("span"),ge.textContent=Ct,ke=n(),T=s("div"),f(re.$$.fragment),mt=n(),_e=s("p"),_e.innerHTML=Ft,Le=n(),De=s("p"),this.h()},l(e){const i=Jt("svelte-1phssyn",document.head);m=o(i,"META",{name:!0,content:!0}),i.forEach(r),V=l(e),M=o(e,"P",{}),c(M).forEach(r),oe=l(e),x=o(e,"H1",{class:!0});var se=c(x);w=o(se,"A",{id:!0,class:!0,href:!0});var Et=c(w);be=o(Et,"SPAN",{});var kt=c(be);v(j.$$.fragment,kt),kt.forEach(r),Et.forEach(r),Ue=l(se),ne=o(se,"SPAN",{"data-svelte-h":!0}),h(ne)!=="svelte-u6jsvi"&&(ne.textContent=ft),se.forEach(r),Pe=l(e),z=o(e,"P",{"data-svelte-h":!0}),h(z)!=="svelte-9vmlu9"&&(z.innerHTML=vt),Te=l(e),G=o(e,"P",{"data-svelte-h":!0}),h(G)!=="svelte-1pqgjjv"&&(G.innerHTML=gt),Ie=l(e),D=o(e,"H2",{class:!0});var Ne=c(D);C=o(Ne,"A",{id:!0,class:!0,href:!0});var Lt=c(C);Me=o(Lt,"SPAN",{});var At=c(Me);v(W.$$.fragment,At),At.forEach(r),Lt.forEach(r),Ye=l(Ne),le=o(Ne,"SPAN",{"data-svelte-h":!0}),h(le)!=="svelte-12o6a2j"&&(le.textContent=_t),Ne.forEach(r),we=l(e),J=o(e,"P",{"data-svelte-h":!0}),h(J)!=="svelte-ofeuxc"&&(J.innerHTML=St),Ce=l(e),y=o(e,"H2",{class:!0});var Oe=c(y);F=o(Oe,"A",{id:!0,class:!0,href:!0});var Nt=c(F);$e=o(Nt,"SPAN",{});var Ot=c($e);v(R.$$.fragment,Ot),Ot.forEach(r),Nt.forEach(r),Be=l(Oe),ie=o(Oe,"SPAN",{"data-svelte-h":!0}),h(ie)!=="svelte-1nabc5r"&&(ie.textContent=bt),Oe.forEach(r),Fe=l(e),d=o(e,"DIV",{class:!0});var u=c(d);v(U.$$.fragment,u),Xe=l(u),ae=o(u,"P",{"data-svelte-h":!0}),h(ae)!=="svelte-25li7n"&&(ae.innerHTML=Mt),Ze=l(u),de=o(u,"P",{"data-svelte-h":!0}),h(de)!=="svelte-linuuh"&&(de.innerHTML=$t),Ke=l(u),$=o(u,"DIV",{class:!0});var Se=c($);v(Y.$$.fragment,Se),Qe=l(Se),ce=o(Se,"P",{"data-svelte-h":!0}),h(ce)!=="svelte-1st02i8"&&(ce.textContent=xt),et=l(Se),v(E.$$.fragment,Se),Se.forEach(r),tt=l(u),k=o(u,"DIV",{class:!0});var qe=c(k);v(B.$$.fragment,qe),rt=l(qe),pe=o(qe,"P",{"data-svelte-h":!0}),h(pe)!=="svelte-4nw43d"&&(pe.textContent=Dt),qe.forEach(r),st=l(u),L=o(u,"DIV",{class:!0});var He=c(L);v(X.$$.fragment,He),ot=l(He),ue=o(He,"P",{"data-svelte-h":!0}),h(ue)!=="svelte-1d6o6zu"&&(ue.textContent=yt),He.forEach(r),nt=l(u),A=o(u,"DIV",{class:!0});var Ve=c(A);v(Z.$$.fragment,Ve),lt=l(Ve),he=o(Ve,"P",{"data-svelte-h":!0}),h(he)!=="svelte-17nne8p"&&(he.textContent=Pt),Ve.forEach(r),it=l(u),N=o(u,"DIV",{class:!0});var je=c(N);v(K.$$.fragment,je),at=l(je),me=o(je,"P",{"data-svelte-h":!0}),h(me)!=="svelte-1rkfgpx"&&(me.textContent=Tt),je.forEach(r),dt=l(u),O=o(u,"DIV",{class:!0});var ze=c(O);v(Q.$$.fragment,ze),ct=l(ze),fe=o(ze,"P",{"data-svelte-h":!0}),h(fe)!=="svelte-1vzm9q"&&(fe.textContent=It),ze.forEach(r),pt=l(u),q=o(u,"DIV",{class:!0});var Ge=c(q);v(ee.$$.fragment,Ge),ut=l(Ge),ve=o(Ge,"P",{"data-svelte-h":!0}),h(ve)!=="svelte-7jbjgx"&&(ve.textContent=wt),Ge.forEach(r),u.forEach(r),Ee=l(e),P=o(e,"H2",{class:!0});var We=c(P);H=o(We,"A",{id:!0,class:!0,href:!0});var qt=c(H);xe=o(qt,"SPAN",{});var Ht=c(xe);v(te.$$.fragment,Ht),Ht.forEach(r),qt.forEach(r),ht=l(We),ge=o(We,"SPAN",{"data-svelte-h":!0}),h(ge)!=="svelte-1qoi9nz"&&(ge.textContent=Ct),We.forEach(r),ke=l(e),T=o(e,"DIV",{class:!0});var Je=c(T);v(re.$$.fragment,Je),mt=l(Je),_e=o(Je,"P",{"data-svelte-h":!0}),h(_e)!=="svelte-6ojmkw"&&(_e.innerHTML=Ft),Je.forEach(r),Le=l(e),De=o(e,"P",{}),c(De).forEach(r),this.h()},h(){a(m,"name","hf:doc:metadata"),a(m,"content",JSON.stringify(Bt)),a(w,"id","dpmsolvermultistepinverse"),a(w,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(w,"href","#dpmsolvermultistepinverse"),a(x,"class","relative group"),a(C,"id","tips"),a(C,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(C,"href","#tips"),a(D,"class","relative group"),a(F,"id","diffusers.DPMSolverMultistepInverseScheduler"),a(F,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(F,"href","#diffusers.DPMSolverMultistepInverseScheduler"),a(y,"class","relative group"),a($,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(k,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(L,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(A,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(N,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(O,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(q,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(d,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(H,"id","diffusers.schedulers.scheduling_utils.SchedulerOutput"),a(H,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(H,"href","#diffusers.schedulers.scheduling_utils.SchedulerOutput"),a(P,"class","relative group"),a(T,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,i){t(document.head,m),p(e,V,i),p(e,M,i),p(e,oe,i),p(e,x,i),t(x,w),t(w,be),g(j,be,null),t(x,Ue),t(x,ne),p(e,Pe,i),p(e,z,i),p(e,Te,i),p(e,G,i),p(e,Ie,i),p(e,D,i),t(D,C),t(C,Me),g(W,Me,null),t(D,Ye),t(D,le),p(e,we,i),p(e,J,i),p(e,Ce,i),p(e,y,i),t(y,F),t(F,$e),g(R,$e,null),t(y,Be),t(y,ie),p(e,Fe,i),p(e,d,i),g(U,d,null),t(d,Xe),t(d,ae),t(d,Ze),t(d,de),t(d,Ke),t(d,$),g(Y,$,null),t($,Qe),t($,ce),t($,et),g(E,$,null),t(d,tt),t(d,k),g(B,k,null),t(k,rt),t(k,pe),t(d,st),t(d,L),g(X,L,null),t(L,ot),t(L,ue),t(d,nt),t(d,A),g(Z,A,null),t(A,lt),t(A,he),t(d,it),t(d,N),g(K,N,null),t(N,at),t(N,me),t(d,dt),t(d,O),g(Q,O,null),t(O,ct),t(O,fe),t(d,pt),t(d,q),g(ee,q,null),t(q,ut),t(q,ve),p(e,Ee,i),p(e,P,i),t(P,H),t(H,xe),g(te,xe,null),t(P,ht),t(P,ge),p(e,ke,i),p(e,T,i),g(re,T,null),t(T,mt),t(T,_e),p(e,Le,i),p(e,De,i),Ae=!0},p(e,[i]){const se={};i&2&&(se.$$scope={dirty:i,ctx:e}),E.$set(se)},i(e){Ae||(_(j.$$.fragment,e),_(W.$$.fragment,e),_(R.$$.fragment,e),_(U.$$.fragment,e),_(Y.$$.fragment,e),_(E.$$.fragment,e),_(B.$$.fragment,e),_(X.$$.fragment,e),_(Z.$$.fragment,e),_(K.$$.fragment,e),_(Q.$$.fragment,e),_(ee.$$.fragment,e),_(te.$$.fragment,e),_(re.$$.fragment,e),Ae=!0)},o(e){S(j.$$.fragment,e),S(W.$$.fragment,e),S(R.$$.fragment,e),S(U.$$.fragment,e),S(Y.$$.fragment,e),S(E.$$.fragment,e),S(B.$$.fragment,e),S(X.$$.fragment,e),S(Z.$$.fragment,e),S(K.$$.fragment,e),S(Q.$$.fragment,e),S(ee.$$.fragment,e),S(te.$$.fragment,e),S(re.$$.fragment,e),Ae=!1},d(e){e&&(r(V),r(M),r(oe),r(x),r(Pe),r(z),r(Te),r(G),r(Ie),r(D),r(we),r(J),r(Ce),r(y),r(Fe),r(d),r(Ee),r(P),r(ke),r(T),r(Le),r(De)),r(m),b(j),b(W),b(R),b(U),b(Y),b(E),b(B),b(X),b(Z),b(K),b(Q),b(ee),b(te),b(re)}}}const Bt={local:"dpmsolvermultistepinverse",sections:[{local:"tips",title:"Tips"},{local:"diffusers.DPMSolverMultistepInverseScheduler",title:"DPMSolverMultistepInverseScheduler"},{local:"diffusers.schedulers.scheduling_utils.SchedulerOutput",title:"SchedulerOutput"}],title:"DPMSolverMultistepInverse"};function Xt(ye){return jt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class rr extends Gt{constructor(m){super(),Wt(this,m,Xt,Yt,Vt,{})}}export{rr as component};
