import{s as ge,j as he,n as de,o as be}from"../chunks/scheduler.6e0d5ff7.js";import{S as _e,i as $e,g as a,s as i,u as C,E as ye,h as o,f as l,c as n,j as te,y as r,v as Z,k as P,o as ve,a as s,w as J,d as U,t as G,x as L}from"../chunks/index.db83ee3c.js";import{C as ee}from"../chunks/CodeBlock.7bcda9df.js";import{D as we}from"../chunks/DocNotebookDropdown.436d987c.js";function Me(le){let m,q,T,I,f,se="조건부 이미지 생성",W,u,H,c,ie="조건부 이미지 생성을 사용하면 텍스트 프롬프트에서 이미지를 생성할 수 있습니다. 텍스트는 임베딩으로 변환되며, 임베딩은 노이즈에서 이미지를 생성하도록 모델을 조건화하는 데 사용됩니다.",V,g,ne="<code>DiffusionPipeline</code>은 추론을 위해 사전 훈련된 diffusion 시스템을 사용하는 가장 쉬운 방법입니다.",D,h,ae='먼저 <code>DiffusionPipeline</code>의 인스턴스를 생성하고 다운로드할 파이프라인 <a href="https://huggingface.co/models?library=diffusers&amp;sort=downloads" rel="nofollow">체크포인트</a>를 지정합니다.',N,d,oe='이 가이드에서는 <a href="https://huggingface.co/CompVis/ldm-text2im-large-256" rel="nofollow">잠재 Diffusion</a>과 함께 텍스트-이미지 생성에 <code>DiffusionPipeline</code>을 사용합니다:',B,b,E,_,pe=`<code>DiffusionPipeline</code>은 모든 모델링, 토큰화, 스케줄링 구성 요소를 다운로드하고 캐시합니다.
이 모델은 약 14억 개의 파라미터로 구성되어 있기 때문에 GPU에서 실행할 것을 강력히 권장합니다.
PyTorch에서와 마찬가지로 생성기 객체를 GPU로 이동할 수 있습니다:`,S,$,F,y,re="이제 텍스트 프롬프트에서 <code>생성기</code>를 사용할 수 있습니다:",R,v,X,w,me='출력값은 기본적으로 <a href="https://pillow.readthedocs.io/en/stable/reference/Image.html?highlight=image#the-image-class" rel="nofollow"><code>PIL.Image</code></a> 객체로 래핑됩니다.',A,M,fe="호출하여 이미지를 저장할 수 있습니다:",Q,x,Y,k,ue="아래 스페이스를 사용해보고 안내 배율 매개변수를 자유롭게 조정하여 이미지 품질에 어떤 영향을 미치는지 확인해 보세요!",z,p,ce,K,j,O;return u=new we({props:{classNames:"absolute z-10 right-0 top-0",options:[{label:"Mixed",value:"https://colab.research.google.com/github/huggingface/notebooks/blob/main/diffusers_doc/ko/conditional_image_generation.ipynb"},{label:"PyTorch",value:"https://colab.research.google.com/github/huggingface/notebooks/blob/main/diffusers_doc/ko/pytorch/conditional_image_generation.ipynb"},{label:"TensorFlow",value:"https://colab.research.google.com/github/huggingface/notebooks/blob/main/diffusers_doc/ko/tensorflow/conditional_image_generation.ipynb"},{label:"Mixed",value:"https://studiolab.sagemaker.aws/import/github/huggingface/notebooks/blob/main/diffusers_doc/ko/conditional_image_generation.ipynb"},{label:"PyTorch",value:"https://studiolab.sagemaker.aws/import/github/huggingface/notebooks/blob/main/diffusers_doc/ko/pytorch/conditional_image_generation.ipynb"},{label:"TensorFlow",value:"https://studiolab.sagemaker.aws/import/github/huggingface/notebooks/blob/main/diffusers_doc/ko/tensorflow/conditional_image_generation.ipynb"}]}}),b=new ee({props:{code:"ZnJvbSUyMGRpZmZ1c2VycyUyMGltcG9ydCUyMERpZmZ1c2lvblBpcGVsaW5lJTBBJTBBZ2VuZXJhdG9yJTIwJTNEJTIwRGlmZnVzaW9uUGlwZWxpbmUuZnJvbV9wcmV0cmFpbmVkKCUyMkNvbXBWaXMlMkZsZG0tdGV4dDJpbS1sYXJnZS0yNTYlMjIp",highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DiffusionPipeline

<span class="hljs-meta">&gt;&gt;&gt; </span>generator = DiffusionPipeline.from_pretrained(<span class="hljs-string">&quot;CompVis/ldm-text2im-large-256&quot;</span>)`}}),$=new ee({props:{code:"Z2VuZXJhdG9yLnRvKCUyMmN1ZGElMjIp",highlighted:'<span class="hljs-meta">&gt;&gt;&gt; </span>generator.to(<span class="hljs-string">&quot;cuda&quot;</span>)'}}),v=new ee({props:{code:"aW1hZ2UlMjAlM0QlMjBnZW5lcmF0b3IoJTIyQW4lMjBpbWFnZSUyMG9mJTIwYSUyMHNxdWlycmVsJTIwaW4lMjBQaWNhc3NvJTIwc3R5bGUlMjIpLmltYWdlcyU1QjAlNUQ=",highlighted:'<span class="hljs-meta">&gt;&gt;&gt; </span>image = generator(<span class="hljs-string">&quot;An image of a squirrel in Picasso style&quot;</span>).images[<span class="hljs-number">0</span>]'}}),x=new ee({props:{code:"aW1hZ2Uuc2F2ZSglMjJpbWFnZV9vZl9zcXVpcnJlbF9wYWludGluZy5wbmclMjIp",highlighted:'<span class="hljs-meta">&gt;&gt;&gt; </span>image.save(<span class="hljs-string">&quot;image_of_squirrel_painting.png&quot;</span>)'}}),{c(){m=a("meta"),q=i(),T=a("p"),I=i(),f=a("h1"),f.textContent=se,W=i(),C(u.$$.fragment),H=i(),c=a("p"),c.textContent=ie,V=i(),g=a("p"),g.innerHTML=ne,D=i(),h=a("p"),h.innerHTML=ae,N=i(),d=a("p"),d.innerHTML=oe,B=i(),C(b.$$.fragment),E=i(),_=a("p"),_.innerHTML=pe,S=i(),C($.$$.fragment),F=i(),y=a("p"),y.innerHTML=re,R=i(),C(v.$$.fragment),X=i(),w=a("p"),w.innerHTML=me,A=i(),M=a("p"),M.textContent=fe,Q=i(),C(x.$$.fragment),Y=i(),k=a("p"),k.textContent=ue,z=i(),p=a("iframe"),K=i(),j=a("p"),this.h()},l(e){const t=ye("svelte-1phssyn",document.head);m=o(t,"META",{name:!0,content:!0}),t.forEach(l),q=n(e),T=o(e,"P",{}),te(T).forEach(l),I=n(e),f=o(e,"H1",{id:!0,"data-svelte-h":!0}),r(f)!=="svelte-1r6oi1q"&&(f.textContent=se),W=n(e),Z(u.$$.fragment,e),H=n(e),c=o(e,"P",{"data-svelte-h":!0}),r(c)!=="svelte-ywp3eh"&&(c.textContent=ie),V=n(e),g=o(e,"P",{"data-svelte-h":!0}),r(g)!=="svelte-rsjwii"&&(g.innerHTML=ne),D=n(e),h=o(e,"P",{"data-svelte-h":!0}),r(h)!=="svelte-16j05gn"&&(h.innerHTML=ae),N=n(e),d=o(e,"P",{"data-svelte-h":!0}),r(d)!=="svelte-1zljx"&&(d.innerHTML=oe),B=n(e),Z(b.$$.fragment,e),E=n(e),_=o(e,"P",{"data-svelte-h":!0}),r(_)!=="svelte-1swfe66"&&(_.innerHTML=pe),S=n(e),Z($.$$.fragment,e),F=n(e),y=o(e,"P",{"data-svelte-h":!0}),r(y)!=="svelte-yx8neo"&&(y.innerHTML=re),R=n(e),Z(v.$$.fragment,e),X=n(e),w=o(e,"P",{"data-svelte-h":!0}),r(w)!=="svelte-kfigs4"&&(w.innerHTML=me),A=n(e),M=o(e,"P",{"data-svelte-h":!0}),r(M)!=="svelte-1qprq36"&&(M.textContent=fe),Q=n(e),Z(x.$$.fragment,e),Y=n(e),k=o(e,"P",{"data-svelte-h":!0}),r(k)!=="svelte-1av7pf"&&(k.textContent=ue),z=n(e),p=o(e,"IFRAME",{src:!0,frameborder:!0,width:!0,height:!0}),te(p).forEach(l),K=n(e),j=o(e,"P",{}),te(j).forEach(l),this.h()},h(){P(m,"name","hf:doc:metadata"),P(m,"content",JSON.stringify(xe)),P(f,"id",""),he(p.src,ce="https://stabilityai-stable-diffusion.hf.space")||P(p,"src",ce),P(p,"frameborder","0"),P(p,"width","850"),P(p,"height","500")},m(e,t){ve(document.head,m),s(e,q,t),s(e,T,t),s(e,I,t),s(e,f,t),s(e,W,t),J(u,e,t),s(e,H,t),s(e,c,t),s(e,V,t),s(e,g,t),s(e,D,t),s(e,h,t),s(e,N,t),s(e,d,t),s(e,B,t),J(b,e,t),s(e,E,t),s(e,_,t),s(e,S,t),J($,e,t),s(e,F,t),s(e,y,t),s(e,R,t),J(v,e,t),s(e,X,t),s(e,w,t),s(e,A,t),s(e,M,t),s(e,Q,t),J(x,e,t),s(e,Y,t),s(e,k,t),s(e,z,t),s(e,p,t),s(e,K,t),s(e,j,t),O=!0},p:de,i(e){O||(U(u.$$.fragment,e),U(b.$$.fragment,e),U($.$$.fragment,e),U(v.$$.fragment,e),U(x.$$.fragment,e),O=!0)},o(e){G(u.$$.fragment,e),G(b.$$.fragment,e),G($.$$.fragment,e),G(v.$$.fragment,e),G(x.$$.fragment,e),O=!1},d(e){e&&(l(q),l(T),l(I),l(f),l(W),l(H),l(c),l(V),l(g),l(D),l(h),l(N),l(d),l(B),l(E),l(_),l(S),l(F),l(y),l(R),l(X),l(w),l(A),l(M),l(Q),l(Y),l(k),l(z),l(p),l(K),l(j)),l(m),L(u,e),L(b,e),L($,e),L(v,e),L(x,e)}}}const xe={local:"",title:"조건부 이미지 생성"};function ke(le){return be(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ze extends _e{constructor(m){super(),$e(this,m,ke,Me,ge,{})}}export{Ze as component};
